
/*#include "matopt_110929.c"*/

void Lindstrom_bound(double *Y, double *Y_new, double *Z, double *mu,
	double *Lamb, double *SIG, double *sdt_NR, double *para, double alpha, double *X, double *XV, int NX, int NXV,
	int NObs, int *N0_ALL, int **obsloc, int N1, int NLat, int Npara, int N01, int NZ, 
	int FL, int *ACCy, int *ACCy_bs, long *idum)
{
	int iNObs1, iNObs2, iNObs3;
	int jN01, jN2, jN1;
	int kNLat1;
	int lNR1;
	int jNZ1;
	/*int n1;*/
	int itmp;
	int NRYstart, NRYcur, NRdtstart;
	int NAL0=N01*NObs;
	int N0, N1m1=N1-1;
	
	double *a, *b, *mu_lind;
	double *P, *K, *L, *SIGMA0, *SIGMA;
	double *y_new, *y_old;
	
	double *psd_Y, *psd_sdt;
	
	double dtmp;
	
	double prop_new, prop_old, proptmp;
	double like_new, like_old;
	
	double *Yp_new, *Yp_old, *sdtp;
	int Nstep;
	
	double *Zvec0, *Zvec1; 
	
	double *Xcur;
	double *XVcur0, *XVcur1, *XVcur, *XVcurs;
	
	int NR;
	
	a = (double *) mxMalloc(sizeof(double) * NLat);
	b = (double *) mxMalloc(sizeof(double) * NLat);    
	mu_lind = (double *) mxMalloc(sizeof(double) * NLat);    
	P = (double *) mxMalloc(sizeof(double) * NLat * NLat);    
	K = (double *) mxMalloc(sizeof(double) * NLat * NLat);
	L = (double *) mxMalloc(sizeof(double) * NLat * NLat);
	SIGMA = (double *) mxMalloc(sizeof(double) * NLat * NLat);
	SIGMA0 = (double *) mxMalloc(sizeof(double) * NLat * NLat);
	y_new = (double *) mxMalloc(sizeof(double) * NLat);
	y_old = (double *) mxMalloc(sizeof(double) * NLat);
	psd_Y = (double *) mxMalloc(sizeof(double) * NLat * 3);
	psd_sdt = (double *) mxMalloc(sizeof(double) * 3);
	Zvec0 = (double *) mxMalloc(sizeof(double) * NZ);
	Zvec1 = (double *) mxMalloc(sizeof(double) * NZ);
	
	XVcurs = (double *) mxMalloc(sizeof(double) * NXV * 2);
	
	/*
	for (iNObs1 = 0; iNObs1 < NObs; iNObs1++) {
		vb_eqn_va(Y+iNObs1*N1*NLat, Y_new+iNObs1*N1*NLat, (N0_ALL[iNObs1]*(NR+1)+1)*NLat);
	}
	*/
	vb_eqn_va(Y, Y_new, NObs*N1*NLat);
	/*sdt_NR is a N1 * NObs vector*/
	for (iNObs1 = 0; iNObs1 < NObs; iNObs1++) {
		N0 = N0_ALL[iNObs1];
		iNObs2 = iNObs1 * N1 * NLat; 
		iNObs3 = iNObs1 * N1;  /*not N1-1*/
		
		Xcur=X+iNObs1*NX;
		XVcur0 = XV + iNObs1 * N1m1 * NXV;
		
		for (jN01 = 0; jN01 < N0; jN01++) {
			/* ***
			jN1 = jN01 * (NR + 1);
			*/
			jN1 = obsloc[iNObs1][jN01];
			
			jN2 = jN1*NLat;
			prop_new=0;
			prop_old=0;
			NRYstart = iNObs2 + jN2;
			NRdtstart = iNObs3 + jN1;			
			
			NR = obsloc[iNObs1][jN01+1] - obsloc[iNObs1][jN01] -1;
			
			XVcur1 = XVcur0 + jN1 * NXV;
			
			for (jNZ1=0;jNZ1<NZ;jNZ1++){
				Zvec1[jNZ1]=Z[jNZ1*NAL0 + iNObs1*N01 + jN01 + 1]-mu[jNZ1];
			}
			
			if(jN01>0&&jN01<(N0-1)){	
				for(kNLat1=0;kNLat1<NLat;kNLat1++){
					psd_Y[kNLat1]=Y_new[NRYstart + (NR+2)* NLat + kNLat1];
					psd_Y[2*NLat+kNLat1]=Y_new[NRYstart - NLat + kNLat1];
				}
				
				psd_sdt[0]=0;
				psd_sdt[1]=sdt_NR[NRdtstart + (NR+2)]-sdt_NR[NRdtstart+(NR+1)];
				psd_sdt[2]=psd_sdt[1]+(sdt_NR[NRdtstart+(NR+1)]-sdt_NR[NRdtstart-1]);
				
				for (jNZ1=0;jNZ1<NXV;jNZ1++){
					XVcurs[jNZ1] = XVcur1[(NR+1) * NXV+jNZ1];/*added May 17th, 2014*/
					XVcurs[jNZ1+NXV] = XVcur1[-NXV+jNZ1];/*added May 17th, 2014*/
				}
				
			} else if (jN01==0) {
				for(kNLat1=0;kNLat1<NLat;kNLat1++){
					psd_Y[kNLat1]=Y_new[NRYstart + (NR+2)* NLat + kNLat1];
					psd_Y[2*NLat+kNLat1]=Y_new[NRYstart + kNLat1];
				}
				psd_sdt[0]=0;
				psd_sdt[1]=sdt_NR[NRdtstart + (NR+2)]-sdt_NR[NRdtstart+(NR+1)];
				psd_sdt[2]=psd_sdt[1]+(sdt_NR[NRdtstart+(NR+1)]-sdt_NR[NRdtstart]);
				
				for (jNZ1=0;jNZ1<NXV;jNZ1++){
					XVcurs[jNZ1] = XVcur1[(NR+1) * NXV+jNZ1];/*added May 17th, 2014*/
					XVcurs[jNZ1+NXV] = XVcur1[jNZ1];/*added May 17th, 2014*/
				}
				
			} else {
				for(kNLat1=0;kNLat1<NLat;kNLat1++){
					psd_Y[kNLat1]=Y_new[NRYstart - NLat + kNLat1];
				}
				psd_sdt[0]=sdt_NR[NRdtstart-1];
				psd_sdt[1]=sdt_NR[NRdtstart+(NR+1)];
				
				for (jNZ1=0;jNZ1<NXV;jNZ1++){
					XVcurs[jNZ1] = XVcur1[NR * NXV+jNZ1];/*added May 17th, 2014*/					
				}
				
			}
			
			if(jN01<(N0-1)){									
				Lindstrom_1step_obs(psd_Y, psd_sdt, para, a, b, mu_lind, P, K, L, SIGMA, SIGMA0, y_new, alpha, &proptmp, Xcur, XVcurs, Zvec1, Lamb, SIG, NZ, 1, NLat, NXV, 1, FL, 1, 1, idum);				
			} else {
				Lindstrom_1step_obs_endpoint(psd_Y, psd_sdt, para, a, b, mu_lind, P, K, L, SIGMA, SIGMA0, y_new,  alpha, &proptmp, Xcur, XVcurs, Zvec1, Lamb, SIG, NZ, 1,  NLat, NXV,  1, FL, 1, 1, idum);
			}
			
			vb_eqn_va(y_new, Y_new + NRYstart + (NR+1)*NLat, NLat);
			prop_new+=proptmp;											
			prop_old+=dmvnorm_L(Y + NRYstart + (NR+1)*NLat, L, mu_lind, a, b, NLat, 1);;	
			
			
			if(jN01>0){
				for (jNZ1=0;jNZ1<NZ;jNZ1++){
					Zvec0[jNZ1]=Z[jNZ1*NAL0 + iNObs1*N01 + jN01]-mu[jNZ1];
				}
				
				for(kNLat1=0;kNLat1<NLat;kNLat1++){
					psd_Y[kNLat1]=Y_new[NRYstart - NLat + kNLat1];
					psd_Y[2*NLat+kNLat1]=Y_new[NRYstart + (NR+1) * NLat + kNLat1];
				}
				psd_sdt[0]=sdt_NR[NRdtstart-1];
				psd_sdt[1]=sdt_NR[NRdtstart];
				psd_sdt[2]=sdt_NR[NRdtstart+NR+1];
				
				for (jNZ1=0;jNZ1<NXV;jNZ1++){
					XVcurs[jNZ1] = XVcur1[-NXV+jNZ1];/*added May 17th, 2014*/
					XVcurs[jNZ1+NXV] = XVcur1[jNZ1];/*added May 17th, 2014*/					
				}
				
				Lindstrom_1step_obs(psd_Y, psd_sdt, para, a, b, mu_lind, P, K, L, SIGMA, SIGMA0, y_new, alpha, &proptmp, Xcur, XVcurs, Zvec0, Lamb, SIG, NZ, 1, NLat, NXV, 1, FL, 1, 1, idum);
				vb_eqn_va(y_new, Y_new + NRYstart, NLat);
				prop_new+=proptmp;											
				
				for(kNLat1=0;kNLat1<NLat;kNLat1++){					
					psd_Y[2*NLat+kNLat1]=Y[NRYstart + (NR+1) * NLat + kNLat1];
					psd_Y[NLat+kNLat1]=Y[NRYstart + kNLat1];
				}
				Lindstrom_1step_obs(psd_Y, psd_sdt, para, a, b, mu_lind, P, K, L, SIGMA, SIGMA0, y_new, alpha, &proptmp, Xcur, XVcurs, Zvec0, Lamb, SIG, NZ, 1, NLat, NXV, 1, FL, 0, 1, idum);				
				prop_old+=proptmp;															
			} 
			
			for (lNR1 = 1; lNR1 <= NR; lNR1++) {
				NRYcur = NRYstart + lNR1 * NLat;
				/*XVcur = XVcur1 + (lNR1-1) * NXV;*/
				/*modified brownian bridga 1st order proposal*/
				Lindstrom_1step(Y_new + NRYstart, sdt_NR + NRdtstart, para, a, b, mu_lind, P, K, L, SIGMA, SIGMA0, y_new, alpha, &proptmp, Xcur, XVcur1, lNR1, NLat, NXV, NR, FL, 1, 1, idum);
				vb_eqn_va(y_new, Y_new + NRYcur, NLat);				
				prop_new+=proptmp;
				
				vb_eqn_va(Y + NRYcur, y_new, NLat);	
				Lindstrom_1step(Y + NRYstart, sdt_NR + NRdtstart, para, a, b, mu_lind, P, K, L, SIGMA, SIGMA0, y_new, alpha, &proptmp, Xcur, XVcur1, lNR1, NLat, NXV, NR, FL, 0, 1, idum);	
				prop_old+=proptmp;		
				/*mexPrintf("%d-th individual, %d-th time, %d-th interpolate.....\n", iNObs1, jN01, lNR1);*/
			}
			
			/* **********************likelihood******************************/
			if(jN01==0){
				Yp_new=Y_new + NRYstart;
				Yp_old=Y + NRYstart;
				
				sdtp=sdt_NR + NRdtstart;
				Nstep=(NR+3);
				
				XVcur = XVcur1;				
			} else if (jN01==(N0-1)) {
				Yp_new=Y_new + NRYstart - NLat;
				Yp_old=Y + NRYstart - NLat;
				
				sdtp=sdt_NR + NRdtstart - 1;
				Nstep=(NR+3);
				
				XVcur = XVcur1 - NXV;
			} else {
				Yp_new=Y_new + NRYstart - NLat;
				Yp_old=Y + NRYstart - NLat;
				
				sdtp=sdt_NR + NRdtstart - 1;
				Nstep=(NR+4);
				
				XVcur = XVcur1 - NXV;
			}
			
			like_new = EM_diagcov(Yp_new, sdtp, para, Xcur, XVcur, Nstep, NLat,NXV);
			like_old = EM_diagcov(Yp_old, sdtp, para, Xcur, XVcur, Nstep, NLat,NXV);
			
			if(jN01>0){
				like_new+= ME_loglik(Zvec0, mu, Lamb, Y_new + NRYstart, SIG, NZ, NLat);
				like_old+= ME_loglik(Zvec0, mu, Lamb, Y + NRYstart, SIG, NZ, NLat);
			}
			
			like_new+= ME_loglik(Zvec1, mu, Lamb, Y_new + NRYstart + (NR+1)*NLat, SIG, NZ, NLat);
			like_old+= ME_loglik(Zvec1, mu, Lamb, Y + NRYstart + (NR+1)*NLat, SIG, NZ, NLat);
			/*
			double ME_loglik(double *Zvec, double *mu, double *Lamb, double *Y, double *SIG, int NZ, int NLat)
			*/
			
			dtmp=log(ran2(idum));
			if(dtmp <= like_new+prop_old-like_old-prop_new){
				vb_eqn_va(Y_new + NRYstart, Y + NRYstart, NLat*(NR+2));
				
				for (lNR1 = 0; lNR1 <= (NR+1); lNR1++) {
					itmp=NRYstart + lNR1 * NLat;
					for (kNLat1 = 0; kNLat1 < NLat; kNLat1++) {					
						ACCy[itmp+kNLat1]+=1;
					}
				}
				
			}else{
				vb_eqn_va(Y+NRYstart, Y_new+NRYstart, NLat*(NR+2));
			}
			
			ACCy_bs[iNObs1+jN01*NObs] +=1;
			
		}
		
		
	}
	
	mxFree(XVcurs);
	
	mxFree(Zvec1);
	mxFree(Zvec0);
	
	mxFree(psd_sdt);
	mxFree(psd_Y);
	mxFree(y_old);
	mxFree(y_new);
	mxFree(SIGMA0);
	mxFree(SIGMA);
	mxFree(L);
	mxFree(K);
	mxFree(P);	
	mxFree(mu_lind);
	mxFree(b);
	mxFree(a);
	
}

