/*
* No use, Y0
*/
#define NU 500

#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdbool.h>

#if defined (_WIN32)
    #include <malloc.h>
#elif defined (__linux__)
    #include <malloc.h>
#elif defined (__APPLE__)
	#include <sys/malloc.h>
#endif

/*
#ifdef __cplusplus 
    extern "C" bool utIsInterruptPending();
#else
    extern bool utIsInterruptPending();
#endif
*/

/*#include <malloc.h>
#include <sys/malloc.h>*/
#include "mex.h"

#include "gsl/gsl_rng.h"
#include "gsl/gsl_randist.h"
#include <gsl/gsl_cdf.h>

#include "nrutil.h"
#include "nrutil.c"
#include "ran_routine.c"
#include "choldc.c"
#include "cholsl.c"
#include "newsy.c"
#include "newsy0.c"
#include "newsy2.c"
#include "newsy2_trun.c"
#include "newsy0_trun.c"

#include "newmu.c"

#include "self_fun.c"
#include "fixed_fun.c"

#include "asa066.h"
#include "asa066.c"

#include "compare.c"

#include "matopt_110929.c"
#include "Lindstrom.c"
#include "Lindstrom_bound.c"

#include "indep_MH.c"



long dum;
unsigned long udum;
long *idum;

gsl_rng *rgsl;  /* global generator */

char errstr0[] = "";
char errstr1[] = "";
char errstr2[] = "";


int *ACCy_bs;

void Initialize_seed()
{
	
	double *pout, *pin;
	mxArray *pIn, *pOut;
	
	idum = &dum;
	
	pIn = mxCreateDoubleMatrix(1, 1, mxREAL);
	pOut = mxCreateDoubleMatrix(1, 1, mxREAL);
	pin = mxGetPr(pIn);
	pin[0] = 100000;
	mexCallMATLAB(1, &pOut, 1, &pIn, "randi");
	pout = mxGetPr(pOut);
	dum = (long int) (-pout[0]);
}




void mexFunction(int nlhs, mxArray * plhs[], int nrhs, const mxArray * prhs[])
{
	#define pIns prhs[0]
	#define pIna prhs[1]
	
	int stepprint=0;
	
	int N,
	mc,
	mcab,
	mcab1,
	mcab2,
	Nrec,
	i, i1, i2, i3, j1, j2, j3, j4, j5, k1, k2, k3, k4, k5, N1, jnr, N10, empi, itmp, itmp1, itmp2, itmp3, itmp4, NLY;
	int N1tmp, N1m1, N1m1sum, N1m10;
	
	double dtmp, cr_ind, dtmp1, dtmp2, dtmp3;
	int NAL0, N01, *N1m1_ALL;
	double *Y_ptrtmp;
	
	double *N0_ALL_M;
	int *N0_ALL, *N01_ALL;
	
	double yvar, ymean, y_new, ysd, logr_num, logr_den, r, low, upp, low1, upp1;
	double *para_new, prior_num, prior_den, prop_num, prop_den, *yv_new;
	double *Lamb0, *mu0, *SIG0;
	
	double *Y0, *YM, *YM0, *para0, *dt_NR0, *yrange, *pararange, *tuna, *tunaM, *parahyp, *numhyp0, *NR_ALL;    /* *Y01, */
	double *para, *dt_NR, *dt_NR1;
	/*
	* MC4
	*/
	double *Y_new, *Y_new0;
	double pi_trial_k, pi_old_k, pi_trial_2kp1, tau_old_2kp1, pi_old_2kp1, tau_trial_2kp1;
	/*
	* MC4
	*/
	
	int MCMAX, Nburn, NObs, NLat, N0, Npara, NNR;
	int NZ;
	double MRMp;
	int NX, NXdyn, NYdyn;
	double *X0, *X, *DX_new, *Xcur;
	
	int *numhyp, NR, NR0;
	double *Y, **EY, **EY0, *Y1, *Y2;
	double *Lamb, *Lamb_new, *ILamb, *mu, *mu_new, *Imu, *SIG, *SIG_new, *SIGI, *Z, *Z0, *Pmu, *PMLamb, *PSLamb, *PSIG;
	
	double *Epara, *Epara0;
	int *ACCy, ACCy1, *ACCP;
	
	char buffer[100];
	FILE *dat;
	



	mxArray *pMCMAX, *pNburn, *pNObs, *pNLat, *pN0, *pNpara, *pMRMp, *pNNR, *pNZ, *pFL;
	
	mxArray *pY0, *ppara, *pdt_NR, *pyrange, *ppararange, *ptun, *pparahyp, *pnumhyp, *pNR_ALL;
	mxArray *pLamb, *pILamb, *pmu, *pImu, *pSIG, *pSIGI, *pZ0, *pPmu, *pPMLamb, *pPSLamb, *pPSIG, *pYM0;
	mxArray *pYtun;
	mxArray *pindscale, *palpha, *pbridgeprop;
	
	mxArray *pN0_ALL_M, *pnthin;
	
	mxArray *pNX, *pX;
	
	mxArray *pobsloc;

	mxArray *pNXV, *pXV;



	int FL;
	
	double *Zc;
	int *NFLamb, *LFLamb;
	
	double *EMU, *ELY, *EPSI, *Ytun, *EMU0, *ELY0, *EPSI0;
	
	double indscale, alpha, alpha0 = 0.0, bridgeprop;
	double *sdt_NR;
	
	int NMRP = 8;
	double *ymr_new, *ymr_old;
	double *dt_mrp, *sdt_mrp, *sdt_mrp1;
	
	double *a, *b, *mu_lind;
	double *P, *K, *L, *SIGMA0, *SIGMA;
	
	double proptmp;
	
	double *Y_mrp, *Y_mrp_new;
	double h_trial, h_old;
	
	
	int *CLMdyn, *ROWdyn;
	double DYLY[NU], DYPSI[NU], DYPPSI[NU];
	double *PLYdyn, *PSLYdyn;
	double DYPSIIND[NU];
	double betmh[NU], betmh0[NU], betm[NU], betiSig[NU];
	int ACC_dyn_mh[NU];
	
	double *Zvec, *mutmp;
	int nthin, ithin;
	float ftmp;
	
	double *fobsloc;
	int **obsloc, **obsloc0;
	
	const gsl_rng_type *Tgsl;
	
	
	double *IMHEmpara, *IMHCovpara, *IMHCCovpara;
	double *IMHEmpara0, *IMHCovpara0, *IMHCCovpara0;
	int imhfactor=1;
	double para_samp_prob;
	
	double *p1, *p2, *ptype;
	int *vec_nobs;
	
	
	
	
	int mhidx[NU];
	double *constr_mat1; int *ineq_flag1; double *constr_a1; int Ncon1; int nidx1;
	double *constr_mat2; int *ineq_flag2; double *constr_a2; int Ncon2; int nidx2;
	double *constr_mat3; int *ineq_flag3; double *constr_a3; int Ncon3; int nidx3;
	double *constr_mat4; int *ineq_flag4; double *constr_a4; int Ncon4; int nidx4;
	double *constr_mat5; int *ineq_flag5; double *constr_a5; int Ncon5; int nidx5;
	double *constr_mat6; int *ineq_flag6; double *constr_a6; int Ncon6; int nidx6;
	double *constr_mat7; int *ineq_flag7; double *constr_a7; int Ncon7; int nidx7;
	
	
	double *XVM, *XV, *XV1, *XVcur0, *XVcur1, *XVcur;
	int NXV;
	double dtcur1;
	/* *************************** */
	
	
	if (idum == 0) {
		Initialize_seed();
		mexPrintf("seed initialized %d.\n", dum);
	}
	
	
	gsl_rng_env_setup();
	Tgsl = gsl_rng_default;
	rgsl = gsl_rng_alloc(Tgsl);
	
	udum = (unsigned long int) -dum;
	mexPrintf("GSL seed initialized %d.\n", udum);
	gsl_rng_set(rgsl,udum);
	
	dtmp = gsl_rng_uniform(rgsl);
	mexPrintf("%f\n",dtmp);
	
	pMCMAX = mxGetCell(pIns, 0);
	pNburn = mxGetCell(pIns, 1);
	pNObs = mxGetCell(pIns, 2);
	pNLat = mxGetCell(pIns, 3);
	pN0 = mxGetCell(pIns, 4);
	pNpara = mxGetCell(pIns, 5);
	pMRMp = mxGetCell(pIns, 6);
	pNNR = mxGetCell(pIns, 7);
	pNZ = mxGetCell(pIns, 8);
	pFL = mxGetCell(pIns, 9);
	pindscale = mxGetCell(pIns, 10);
	palpha = mxGetCell(pIns, 11);
	pbridgeprop = mxGetCell(pIns, 12);
	pnthin = mxGetCell(pIns, 13);
	pNX = mxGetCell(pIns, 14);
	pNXV = mxGetCell(pIns, 15);
	
	MCMAX = (int) mxGetScalar(pMCMAX);
	Nburn = (int) mxGetScalar(pNburn);
	NObs = (int) mxGetScalar(pNObs);
	NLat = (int) mxGetScalar(pNLat);
	N0 = (int) mxGetScalar(pN0);
	Npara = (int) mxGetScalar(pNpara);
	MRMp = mxGetScalar(pMRMp);
	NNR = (int) mxGetScalar(pNNR);
	NZ = (int) mxGetScalar(pNZ);
	FL = (int) mxGetScalar(pFL);
	indscale = mxGetScalar(pindscale);
	alpha = mxGetScalar(palpha);
	bridgeprop = mxGetScalar(pbridgeprop);
	nthin = (int) mxGetScalar(pnthin);
	NX = (int) mxGetScalar(pNX);
	NXV = (int) mxGetScalar(pNXV);
	
	/*
	MCMAX = (int) 50;
	Nburn = (int) 10;
	NObs = (int) 20;
	NLat = (int) 1;
	N0 = (int) 110;
	Npara = (int) 8;
	MRMp = 1-0.3;
	NNR = 1;
	NZ = 3;
	FL = 0;
	indscale = 1;
	alpha = 0;
	bridgeprop = 0;
	nthin = 1;
	NX = 2;
	*/
	
	Nrec = MCMAX - Nburn;
	N1m1_ALL = (int *) mxMalloc(sizeof(int) * NObs);
	
	
	pY0 = mxGetCell(pIna, 0);
	ppara = mxGetCell(pIna, 1);
	pdt_NR = mxGetCell(pIna, 2);
	pyrange = mxGetCell(pIna, 3);
	ppararange = mxGetCell(pIna, 4);
	ptun = mxGetCell(pIna, 5);
	pparahyp = mxGetCell(pIna, 6);
	pnumhyp = mxGetCell(pIna, 7);
	pNR_ALL = mxGetCell(pIna, 8);
	pLamb = mxGetCell(pIna, 9);
	pILamb = mxGetCell(pIna, 10);
	pmu = mxGetCell(pIna, 11);
	pImu = mxGetCell(pIna, 12);
	pSIG = mxGetCell(pIna, 13);
	pSIGI = mxGetCell(pIna, 14);
	pZ0 = mxGetCell(pIna, 15);
	pPmu = mxGetCell(pIna, 16);
	pPMLamb = mxGetCell(pIna, 17);
	pPSLamb = mxGetCell(pIna, 18);
	pPSIG = mxGetCell(pIna, 19);
	pYM0 = mxGetCell(pIna, 20);
	pN0_ALL_M = mxGetCell(pIna, 21);
	pYtun = mxGetCell(pIna, 22);
	pX = mxGetCell(pIna, 23);
	pobsloc = mxGetCell(pIna,24);
	pXV = mxGetCell(pIna,25);
	
	
	
	
	
	YM = mxGetPr(pY0);
	para0 = mxGetPr(ppara);
	dt_NR0 = mxGetPr(pdt_NR);
	yrange = mxGetPr(pyrange);
	pararange = mxGetPr(ppararange);
	tunaM = mxGetPr(ptun);
	parahyp = mxGetPr(pparahyp);
	numhyp0 = mxGetPr(pnumhyp);
	NR_ALL = mxGetPr(pNR_ALL);
	Lamb0 = mxGetPr(pLamb);
	ILamb = mxGetPr(pILamb);
	mu0 = mxGetPr(pmu);
	Imu = mxGetPr(pImu);
	SIG0 = mxGetPr(pSIG);
	SIGI = mxGetPr(pSIGI);
	Z0 = mxGetPr(pZ0);
	Pmu = mxGetPr(pPmu);
	PMLamb = mxGetPr(pPMLamb);
	PSLamb = mxGetPr(pPSLamb);
	PSIG = mxGetPr(pPSIG);
	YM0 = mxGetPr(pYM0);
	N0_ALL_M = mxGetPr(pN0_ALL_M);
	Ytun = mxGetPr(pYtun);
	X0 = mxGetPr(pX);
	fobsloc = mxGetPr(pobsloc);
	XVM = mxGetPr(pXV);
	
	/*
	NR_ALL=dvector(0,NNR-1);
	NR_ALL[0]=7;
	
	
	NR=NR_ALL[0];
	N1=N0*(NR+1)+1;
	
	
	
	YM=dvector(0,NLat*NObs*((NR+1)*(N0)+1)-1);		
	para0=dvector(0,Npara-1);
	dt_NR0=dvector(0,NObs*((NR+1)*(N0))-1);
	yrange=dvector(0,NLat*(2)-1);
	pararange=dvector(0,Npara*2-1);
	tunaM=dvector(0,Npara-1);
	parahyp=dvector(0,Npara*3-1);
	numhyp0=dvector(0,Npara-1);
	Lamb0=dvector(0,NZ*NLat-1);
	ILamb=dvector(0,NZ*NLat-1);
	mu0=dvector(0,NZ);
	Imu=dvector(0,NZ);
	SIG0=dvector(0,NZ);
	SIGI=dvector(0,NZ);
	Z0=dvector(0,NZ*(N0+1)*NObs-1);
	Pmu=dvector(0,NZ*2);	
	PMLamb=dvector(0,NZ*NLat-1);
	PSLamb=dvector(0,NZ*NLat-1);
	PSIG=dvector(0,NZ*2);
	YM0=dvector(0,NLat*NObs*(N0+1)-1);
	N0_ALL_M = dvector(0,NObs-1);
	Ytun = dvector(0,NLat-1);
	X0 = dvector(0,NX*NObs-1);
	fobsloc = dvector(0,(N0+1)*NObs-1);
	
	for(i=0;i<(NLat*NObs*((NR+1)*(N0)+1));i++){
		YM[i]=gasdev(idum);
	}
	para0[0]=1;para0[1]=1;para0[2]=1;para0[3]=1;
	para0[4]=1;para0[5]=1;para0[6]=1;para0[7]=1;
	for(i=0;i<NObs*((NR+1)*(N0));i++){
		dt_NR0[i]=0.05;
	}
	yrange[0]=-20000000;yrange[1]=-20000000;
	pararange[0]=-20000000;pararange[1]=20000000;
	tunaM[0]=0.1;tunaM[1]=0.1;tunaM[2]=0.02;
	for(i1=0;i1<Npara;i1++){
		parahyp[i1]=0;parahyp[i1+Npara]=1;parahyp[i1+Npara*2]=1;	
	}
	numhyp0[0]=0;numhyp0[1]=2;numhyp0[2]=4;	
	Lamb0[0]=1;Lamb0[1]=1;Lamb0[2]=1;
	ILamb[0]=0;ILamb[1]=1;ILamb[2]=1;
	for(i1=0;i1<NZ;i1++){
		mu0[i1]=0;
		Imu[i1]=1;
		SIG0[i1]=0.3;
		SIGI[i1]=1;
	}
	for(i1=0;i1<NZ*(N0+1)*NObs;i1++){
		Z0[i1]=gasdev(idum);
	}
	for(i1=0;i1<NZ;i1++){
		Pmu[i1]=0;
		Pmu[i1+NZ]=1;
	}
	PMLamb[0]=1;PMLamb[1]=1;PMLamb[2]=1;
	PSLamb[0]=1;PSLamb[1]=1;PSLamb[2]=1;
	for(i1=0;i1<NZ;i1++){
		PSIG[i1]=3;
		PSIG[i1+NZ]=0.6;
	}
	for(i=0;i<(NLat*NObs*(N0+1));i++){
		YM0[i]=gasdev(idum);
	}
	for(i=0;i<(NObs);i++){
		N0_ALL_M[i] = 110;
	}
	Ytun[0]=1;
	for(i=0;i<NX*NObs;i++){
		X0[i] = 0.25*ran2(idum);
	}
	for(i=0;i<NObs;i++){
		i2=0;
		for(i1=0;i1<(N0+1);i1++){
			fobsloc[i+i1*NObs] = i2;
			i2 = i2 + 8;
		}
	}
	*/
	
	
	
	
	X = (double *) mxMalloc(sizeof(double) * NObs * NX);
	
	a = (double *) mxMalloc(sizeof(double) * NLat);
	b = (double *) mxMalloc(sizeof(double) * NLat);
	mu_lind = (double *) mxMalloc(sizeof(double) * NLat);
	P = (double *) mxMalloc(sizeof(double) * NLat * NLat);
	K = (double *) mxMalloc(sizeof(double) * NLat * NLat);
	L = (double *) mxMalloc(sizeof(double) * NLat * NLat);
	SIGMA = (double *) mxMalloc(sizeof(double) * NLat * NLat);
	SIGMA0 = (double *) mxMalloc(sizeof(double) * NLat * NLat);
	
	ymr_new = (double *) mxMalloc(sizeof(double) * NLat * (2 + NMRP));
	ymr_old = (double *) mxMalloc(sizeof(double) * NLat * (2 + NMRP));
	
	N0_ALL = (int *) mxMalloc(sizeof(int) * NObs);
	N01_ALL = (int *) mxMalloc(sizeof(int) * NObs);
	
	
	NXdyn = 3;
	NYdyn = 4;
	
	CLMdyn = (int *) mxMalloc(sizeof(int) * NYdyn * NXdyn);
	ROWdyn = (int *) mxMalloc(sizeof(int) * NYdyn);
	PLYdyn = (double *) mxMalloc(sizeof(double) * NYdyn * NXdyn);
	PSLYdyn = (double *) mxMalloc(sizeof(double) * NYdyn * NXdyn);
	
	CLMdyn[0] = 0;
    CLMdyn[4] = 0;
    CLMdyn[8] = 0;
    CLMdyn[1] = 0;
    CLMdyn[5] = 1;
    CLMdyn[9] = 2;
    CLMdyn[2] = 0;
    CLMdyn[6] = 1;
    CLMdyn[10] = 2;
    CLMdyn[3] = 0;
    CLMdyn[7] = 0;
    CLMdyn[11] = 0;
	
	ROWdyn[0] = 1;
	ROWdyn[1] = 3;
	ROWdyn[2] = 3;
	ROWdyn[3] = 0;
	
	PLYdyn[0] = 0;
	PLYdyn[4] = 0;
	PLYdyn[8] = 0;
	PLYdyn[1] = 0;
	PLYdyn[5] = 0;
	PLYdyn[9] = 0;
	PLYdyn[2] = 0;
	PLYdyn[6] = 0;
	PLYdyn[10] = 0;
	PLYdyn[3] = 0;
	PLYdyn[7] = 0;
	PLYdyn[11] = 0;
	
	PSLYdyn[0] = 100;
	PSLYdyn[4] = 100;
	PSLYdyn[8] = 100;
	PSLYdyn[1] = 100;
	PSLYdyn[5] = 100;
	PSLYdyn[9] = 100;
	PSLYdyn[2] = 100;
	PSLYdyn[6] = 100;
	PSLYdyn[10] = 100;
	PSLYdyn[3] = 100;
	PSLYdyn[7] = 100;
	PSLYdyn[11] = 100;
	
	DYPSI[0] = 1;
	DYPSI[1] = 1;
	DYPSI[2] = 1;
	DYPSI[3] = 1;
	
	DYPPSI[0] = 3;
	DYPPSI[1] = 3;
	DYPPSI[2] = 3;
	DYPPSI[3] = 3;
	DYPPSI[4] = 2;
	DYPPSI[5] = 2;
	DYPPSI[6] = 2;
	DYPPSI[7] = 2;
	
	DYLY[0] = 0;
	DYLY[4] = 0;
	DYLY[8] = 0;
	DYLY[1] = 0;
	DYLY[5] = 0;
	DYLY[9] = 0;
	DYLY[2] = 0;
	DYLY[6] = 0;
	DYLY[10] = 0;
	DYLY[3] = 0;
	DYLY[7] = 0;
	DYLY[11] = 0;
	
	DYPSIIND[0] = 0;
	DYPSIIND[1] = 1;
	DYPSIIND[2] = 0;
	DYPSIIND[3] = 0;
	
	betmh[2] = para0[1];
	betmh[0] = para0[2];
	betmh[1] = para0[3];
	betmh0[0] = 0.0;/*0;*/
	betmh0[1] = 0.5;/*0;*/
	betmh0[2] = -0.5;/*0;*/
	betm[0] = 1.0;
	betm[1] = -1.0;
	betm[2] = 0;
	for (j1 = 0; j1 < 9; j1++) {
		betiSig[j1] = 0;
	}
	betiSig[0] = 0.0000001;
	betiSig[4] = 0.0000001;
	betiSig[8] = 0.0000001;
	
	ACC_dyn_mh[0] = 0;
	ACC_dyn_mh[1] = 0;
	ACC_dyn_mh[2] = 0;
	ACC_dyn_mh[3] = 0;
	
	para = (double *) mxMalloc(sizeof(double) * Npara);
	/*
	* dynamic parameters in the current state
	*/
	para_new = (double *) mxMalloc(sizeof(double) * Npara);
	/*
	* dynamic parameters in the proposal state
	*/
	numhyp = (int *) mxMalloc(sizeof(int) * Npara);
	/*
	* location of hyperparameter for dynamicl parameters
	*/
	yv_new = (double *) mxMalloc(sizeof(double) * NLat);
	/*
	* latent variable in the proposal state
	*/
	Zc = (double *) mxMalloc(sizeof(double) * (N0 + 1) * NObs); /* centered observed variable */
	NFLamb = (int *) mxMalloc(sizeof(int) * NZ);
	/*
	* number of lambda to be estimated in each row of Lambda
	*/
	LFLamb = (int *) mxMalloc(sizeof(int) * NZ * NLat);
	/*
	* location of lambda to be estimated in each row of Lambda
	*/
	Z = (double *) mxMalloc(sizeof(double) * (N0 + 1) * NObs * NZ);	    /* reordered observed variable (N0+1)*NObs*NZ */
	Y0 = (double *) mxMalloc(sizeof(double) * (N0 + 1) * NObs * NLat);  /* reordered latent variable (N0+1)*NObs*NLat */
	
	Lamb = (double *) mxMalloc(sizeof(double) * NZ * NLat);
	mu = (double *) mxMalloc(sizeof(double) * NZ);
	SIG = (double *) mxMalloc(sizeof(double) * NZ);
	
	Lamb_new = (double *) mxMalloc(sizeof(double) * NZ * NLat);
	mu_new = (double *) mxMalloc(sizeof(double) * NZ);
	SIG_new = (double *) mxMalloc(sizeof(double) * NZ);
	
	Zvec = (double *) mxMalloc(sizeof(double) * NZ);
	mutmp = (double *) mxMalloc(sizeof(double) * NLat);
	
	for (j1 = 0; j1 < NObs; j1++) {
		N0_ALL[j1] = (int) N0_ALL_M[j1];
		N01_ALL[j1] = N0_ALL[j1] + 1;
	}
	
	obsloc = imatrix(0,NObs-1,0,N0);
	obsloc0 = imatrix(0,NObs-1,0,N0);
	for(j1=0;j1<NObs;j1++){
		for(j2=0;j2<=N0;j2++){
			obsloc[j1][j2] = (int) fobsloc[j1+j2*NObs];
		}
	}
	
	for (j1 = 0; j1 < NZ; j1++) {
		for (j2 = 0; j2 < NLat; j2++) {
			Lamb[j1 + j2 * NZ] = Lamb0[j1 + j2 * NZ];
		}
		mu[j1] = mu0[j1];
		SIG[j1] = SIG0[j1];
	}
	
	/*
	* reorder Z0 (NZ*(N0+1)*NObs) to Z ((N0+1)*NObs*NZ)
	*/
	N01 = (N0 + 1);
	for (j3 = 0; j3 < NObs; j3++) {
		i1 = N0_ALL[j3] + 1;
		for (j2 = 0; j2 < i1; j2++) {
			for (j1 = 0; j1 < NZ; j1++) {
				Z[j2 + j3 * N01 + j1 * N01 * NObs] = Z0[j1 + j2 * NZ + j3 * NZ * N01];
			}
		}
	}
	
	/*
	* reorder YM0 (NLat*(N0+1)*NObs) to Y0 ((N0+1)*NObs*NLat)
	*/
	for (j3 = 0; j3 < NObs; j3++) {
		i1 = N0_ALL[j3] + 1;
		for (j2 = 0; j2 < i1; j2++) {
			for (j1 = 0; j1 < NLat; j1++) {
				Y0[j2 + j3 * N01 + j1 * N01 * NObs] = YM0[j1 + j2 * NLat + j3 * NLat * N01];
			}
		}
	}
	
	for (j3 = 0; j3 < NObs * NX; j3++) {
		X[j3] = X0[j3];
	}
	
	/*
	* initialize
	*/
	for (j1 = 0; j1 < Npara; j1++) {
		para_new[j1] = 0;
		para[j1] = para0[j1];
	}
	for (j1 = 0; j1 < Npara; j1++) {
		numhyp[j1] = (int) numhyp0[j1];
	}
	NLY = 0;
	for (j1 = 0; j1 < NZ; j1++) {
		j3 = 0;
		for (j2 = 0; j2 < NLat; j2++) {
			if (ILamb[j1 + j2 * NZ] == 1) {
				LFLamb[j1 + j3 * NZ] = j2;
				j3++;
			}
		}
		NFLamb[j1] = j3;
		NLY += j3;
	}
	/*
	* to save MCMC output of parameters in measurement equation.
	*/
	EMU = (double *) mxMalloc(sizeof(double) * Nrec * NZ);
	ELY = (double *) mxMalloc(sizeof(double) * Nrec * NLY);
	EPSI = (double *) mxMalloc(sizeof(double) * Nrec * NZ);
	
	EMU0 = (double *) mxMalloc(sizeof(double) * Nrec * NZ);
	ELY0 = (double *) mxMalloc(sizeof(double) * Nrec * NLY);
	EPSI0 = (double *) mxMalloc(sizeof(double) * Nrec * NZ);
	tuna = (double *) mxMalloc(sizeof(double) * Npara);
	
	
	
	IMHEmpara0 = (double *) mxMalloc(sizeof(double) * Npara);
	IMHCovpara0 = (double *) mxMalloc(sizeof(double) * Npara * Npara);initializ_MA(IMHCovpara0,Npara,Npara);
	IMHCCovpara0 = (double *) mxMalloc(sizeof(double) * Npara * Npara);initializ_MA(IMHCCovpara0,Npara,Npara);
	
	IMHEmpara = (double *) mxMalloc(sizeof(double) * Npara);
	IMHCovpara = (double *) mxMalloc(sizeof(double) * Npara * Npara);initializ_MA(IMHCovpara,Npara,Npara);
	IMHCCovpara = (double *) mxMalloc(sizeof(double) * Npara * Npara);initializ_MA(IMHCCovpara,Npara,Npara);
	
	
	for(j1=0;j1<Npara;j1++){
		IMHEmpara0[j1] = 0;
		for(j2 = 0;j2<Npara;j2++){
			IMHCovpara0[j2+j1*Npara]=0;
			IMHCovpara[j2+j1*Npara]=0;
		}
		IMHCovpara0[j1+j1*Npara]=0.0025;/*0.000025;*/
		IMHCovpara[j1+j1*Npara]=0.0025;/*0.000025;*/
	}
	band_choldc_c(IMHCovpara0, IMHCCovpara0, &Npara, &Npara);
	band_choldc_c(IMHCovpara, IMHCCovpara, &Npara, &Npara);
	/*
	mexPrintf("Cov check\n");
	printmatrix(IMHCovpara0,Npara,Npara);
	printmatrix(IMHCCovpara0,Npara,Npara);
	mexPrintf("Cov check\n");
	*/
	
	p1 = parahyp;
	p2 = parahyp+Npara;
	ptype = p2 + Npara;
	
	/*
	* sum of observed time time including initial conditions of all individuals
	*/
	N = 0;
	for (j1 = 0; j1 < NObs; j1++) {
		N += N0_ALL[j1];
	}
	
	N01 = (N0 + 1);
	NAL0 = NObs * N01;
	N1 = 1;			    /* give value to first N10 */
	
	vec_nobs = (int *) mxMalloc(sizeof(int) * NObs);
	
	
	Ncon1 = NObs; Ncon2 = 0; Ncon3 = NObs; Ncon4 = NObs;Ncon5 = 0; Ncon6 = NObs; Ncon7 = 1;
	nidx1 = 7; nidx2 = 7; nidx3 = 7; nidx4 = 7; nidx5 = 7; nidx6 = 7; nidx7 = 3;
	constr_mat1 = (double *) mxMalloc(sizeof(double) * Ncon1 * nidx1);initializ_MA(constr_mat1,Ncon1,nidx1);
	constr_mat2 = (double *) mxMalloc(sizeof(double) * Ncon2 * nidx2);initializ_MA(constr_mat2,Ncon2,nidx2);
	constr_mat3 = (double *) mxMalloc(sizeof(double) * Ncon3 * nidx3);initializ_MA(constr_mat3,Ncon3,nidx3);
	constr_mat4 = (double *) mxMalloc(sizeof(double) * Ncon4 * nidx4);initializ_MA(constr_mat4,Ncon4,nidx4);
	constr_mat5 = (double *) mxMalloc(sizeof(double) * Ncon5 * nidx5);initializ_MA(constr_mat5,Ncon5,nidx5);
	ineq_flag1 = (int *) mxMalloc(sizeof(int) * Ncon1);initializ_iMA(ineq_flag1,Ncon1,1);
	ineq_flag2 = (int *) mxMalloc(sizeof(int) * Ncon2);initializ_iMA(ineq_flag2,Ncon2,1);
	ineq_flag3 = (int *) mxMalloc(sizeof(int) * Ncon3);initializ_iMA(ineq_flag3,Ncon3,1);
	ineq_flag4 = (int *) mxMalloc(sizeof(int) * Ncon4);initializ_iMA(ineq_flag4,Ncon4,1);
	ineq_flag5 = (int *) mxMalloc(sizeof(int) * Ncon5);initializ_iMA(ineq_flag5,Ncon5,1);
	constr_a1 = (double *) mxMalloc(sizeof(double) * Ncon1);initializ_MA(constr_a1,Ncon1,1);
	constr_a2 = (double *) mxMalloc(sizeof(double) * Ncon2);initializ_MA(constr_a2,Ncon2,1);
	constr_a3 = (double *) mxMalloc(sizeof(double) * Ncon3);initializ_MA(constr_a3,Ncon3,1);
	constr_a4 = (double *) mxMalloc(sizeof(double) * Ncon4);initializ_MA(constr_a4,Ncon4,1);
	constr_a5 = (double *) mxMalloc(sizeof(double) * Ncon5);initializ_MA(constr_a5,Ncon5,1);
	
	constr_mat6 = (double *) mxMalloc(sizeof(double) * Ncon6 * nidx6+1);initializ_MA(constr_mat6,Ncon6,nidx6);
	ineq_flag6 = (int *) mxMalloc(sizeof(int) * Ncon6+1);initializ_iMA(ineq_flag6,Ncon6,1);
	constr_a6 = (double *) mxMalloc(sizeof(double) * Ncon6 +1);initializ_MA(constr_a6,Ncon6,1);
	
	constr_mat7 = (double *) mxMalloc(sizeof(double) * Ncon7 * nidx7+1);initializ_MA(constr_mat7,Ncon7,nidx7);
	ineq_flag7 = (int *) mxMalloc(sizeof(int) * Ncon7+1);initializ_iMA(ineq_flag7,Ncon7,1);
	constr_a7 = (double *) mxMalloc(sizeof(double) * Ncon7 +1);initializ_MA(constr_a7,Ncon7,1);
	
	for(j1=0;j1<Ncon1;j1++){
		constr_mat1[j1+0*Ncon1] = 1;
		constr_mat1[j1+1*Ncon1] = X[0+j1*NX];
		constr_mat1[j1+2*Ncon1] = X[2+j1*NX];
		constr_mat1[j1+3*Ncon1] = X[3+j1*NX];
		constr_mat1[j1+4*Ncon1] = X[4+j1*NX];
		constr_mat1[j1+5*Ncon1] = X[5+j1*NX];
		constr_mat1[j1+6*Ncon1] = X[6+j1*NX];
		
		
		ineq_flag1[j1] = 1;
		constr_a1[j1] = 0;		
	}
	
	
	for(j1=0;j1<Ncon3;j1++){
		constr_mat3[j1+0*Ncon3] = 1;
		constr_mat3[j1+1*Ncon3] = X[0+j1*NX];
		constr_mat3[j1+2*Ncon3] = X[2+j1*NX];
		constr_mat3[j1+3*Ncon3] = X[3+j1*NX];
		constr_mat3[j1+4*Ncon3] = X[4+j1*NX];
		constr_mat3[j1+5*Ncon3] = X[5+j1*NX];
		constr_mat3[j1+6*Ncon3] = X[6+j1*NX];
		
		ineq_flag3[j1] = 1;
		constr_a3[j1] = 0;		
	}
	
	for(j1=0;j1<Ncon4;j1++){
		constr_mat4[j1+0*Ncon4] = 1;
		constr_mat4[j1+1*Ncon4] = X[1+j1*NX];
		constr_mat4[j1+2*Ncon4] = X[2+j1*NX];
		constr_mat4[j1+3*Ncon4] = X[3+j1*NX];
		constr_mat4[j1+4*Ncon4] = X[4+j1*NX];
		constr_mat4[j1+5*Ncon4] = X[5+j1*NX];
		constr_mat4[j1+6*Ncon4] = X[6+j1*NX];
		
		ineq_flag4[j1] = 1;
		constr_a4[j1] = 0;		
	}
	
	for(j1=0;j1<Ncon6;j1++){
		constr_mat6[j1+0*Ncon6] = 1;
		constr_mat6[j1+1*Ncon6] = X[1+j1*NX];
		constr_mat6[j1+2*Ncon6] = X[2+j1*NX];
		constr_mat6[j1+3*Ncon6] = X[3+j1*NX];
		constr_mat6[j1+4*Ncon6] = X[4+j1*NX];
		constr_mat6[j1+5*Ncon6] = X[5+j1*NX];
		constr_mat6[j1+6*Ncon6] = X[6+j1*NX];
		
		ineq_flag6[j1] = 1;
		constr_a6[j1] = 0;		
	}
	
	constr_mat7[0]=1;
	ineq_flag7[0] = 1;
	constr_a7[0] = 0;
	
	/*
	for(j1=0;j1<Ncon5;j1++){
		constr_mat5[j1+0*Ncon5] = 1;
		
		ineq_flag5[j1] = 1;
		constr_a5[j1] = 0;		
	}
	
	for(j1=0;j1<Ncon6;j1++){
		constr_mat6[j1+0*Ncon6] = 1;
		constr_mat6[j1+1*Ncon6] = X[0+j1*NX];
		constr_mat6[j1+2*Ncon6] = X[1+j1*NX];
		
		ineq_flag6[j1] = 1;
		constr_a6[j1] = 0;		
	}
	*/
	ACCy_bs = (int *) mxMalloc(sizeof(int) * NObs * N01);
	
	
	mexPrintf("Input Summary:\n");
	mexPrintf("Number of parameters: %d",Npara);
	
	
	/*
	* initiaize arbitrarily
	*/
	for (jnr = 0; jnr < NNR; jnr++) {
		
		initializ_iMA(ACCy_bs,NObs,N01);
		initializ_iMA(ACC_dyn_mh,NU,1);
		
		N10 = N1;		/* number of time points including augmented latent variables of last resolution. */
		N1m10 = N10 - 1;
		Y2 = (double *) mxMalloc(sizeof(double) * N10 * NObs * NLat);
		
		/*NR = (int) NR_ALL[jnr];
		N1m1 = N0 * (NR + 1);
		N1 = N1m1 + 1;
		*/
		/*when increase resolution, change observed location*/
		if(jnr>0){
			for(j1=0;j1<NObs;j1++){
				for(j2=0;j2<=N0_ALL[j1];j2++){
					obsloc0[j1][j2] = obsloc[j1][j2];
					obsloc[j1][j2] = obsloc[j1][j2] * 2;
				}
			}
		}
		
		for(j1=0;j1<NObs;j1++){
			vec_nobs[j1] = obsloc[j1][N0_ALL[j1]]+1;
		}
		
		N1 = imaxv(vec_nobs, NObs);
		N1m1 = N1 - 1;
		
		
		ACCP = (int *) mxMalloc(sizeof(int) * Npara);
		/*
		* number of acceptance of dynamic parameters
		*/
		ACCy = (int *) mxMalloc(sizeof(int) * N1 * NObs * NLat);
		/*
		* number of acceptance of all latent variables (augmented included)
		*/
		
		/*
		* initialize
		*/
		for (j1 = 0; j1 < Npara; j1++) {
			ACCP[j1] = 0;
		}
		i1 = N1 * NObs * NLat;
		for (j1 = 0; j1 < i1; j1++) {
			ACCy[j1] = 0;
		}
		
		Y_new = (double *) mxMalloc(sizeof(double) * N1 * NObs * NLat);
		/*
		* proposal all latent variables in cross-resolution move
		*/
		Y_new0 = (double *) mxMalloc(sizeof(double) * N1 * NObs * NLat);
		/*
		* proposal all latent variables in cross-resolution move
		*/
		DX_new = (double *) mxMalloc(sizeof(double) * N1 * NObs * Npara);
		
		N1m1sum = 0;
		for (j1 = 0; j1 < NObs; j1++) {
			/* ***
			itmp = N0_ALL[j1] * (NR + 1);
			*/
			itmp = obsloc[j1][N0_ALL[j1]];
			N1m1sum += itmp;
			N1m1_ALL[j1] = itmp;
		}
		
		if (jnr == 0) {
			Y = (double *) mxMalloc(sizeof(double) * N1 * NObs * NLat);
			Y1 = (double *) mxMalloc(sizeof(double) * N10 * NObs * NLat);
			
			XV = (double *) mxMalloc(sizeof(double) * NObs*N1m1*NXV);
			XV1 = (double *) mxMalloc(sizeof(double) * NObs*N1m10*NXV);
			
			/*
			* EY=dmatrix(0,Nrec-1,0,N1*NObs*NLat-1); EY0=dmatrix(0,Nrec-1,0,N10*NObs*NLat-1);
			*/
			dt_NR = (double *) mxMalloc(sizeof(double) * (N1 - 1) * NObs);
			sdt_NR = (double *) mxMalloc(sizeof(double) * (N1) * NObs);
			dt_NR1 = (double *) mxMalloc(sizeof(double) * 1);
			Epara = (double *) mxMalloc(sizeof(double) * Nrec * Npara);
			Epara0 = (double *) mxMalloc(sizeof(double) * 1);
			/*
			dt_mrp = (double *) mxMalloc(sizeof(double) * 1);
			sdt_mrp = (double *) mxMalloc(sizeof(double) * 1);
			
			Y_mrp_new = (double *) mxMalloc(sizeof(double) * 1);
			Y_mrp = (double *) mxMalloc(sizeof(double) * 1);
			*/
			
			i1 = N1 * NObs * NLat;
			/*
			* read latent variables from Matlab. Augmented latent variables included for the first resolution.
			* NLat*N1*NObs
			*/
			/*
			mexPrintf("%d, %d, %d\n",N1, NObs, NLat);
			getchar();
			*/
			for (j1 = 0; j1 < i1; j1++) {
				Y[j1] = YM[j1];
			}
			
			for (j2 = 0; j2 < NObs; j2++) {
				itmp = j2 * N1m1;
				/* ***
				itmp1 = N0_ALL[j2] * (NR + 1);
				*/
				itmp1 = obsloc[j2][N0_ALL[j2]];
				for (j1 = 0; j1 < itmp1; j1++) {
					dt_NR[itmp + j1] = dt_NR0[itmp + j1];
				}
				cumsum(dt_NR + itmp, sdt_NR + j2 * N1, itmp1);
			}
			
			printf("%d,%d,%d\n",N1m1,NR,N0);
			for(i=0;i<NObs;i++){		
				for(i1=0;i1<N1m1;i1++){
					for(i2=0;i2<NXV;i2++){
						XV[i2 + i1*NXV + i * N1m1 * NXV] = XVM[i2 + i1*NXV + i * N1m1 * NXV];
					}
				}
			}
			
			for (j1 = 0; j1 < Npara; j1++) {
				tuna[j1] = tunaM[j1];
			}
		} else {
			mxFree(XV1);
			mxFree(Y1);
			mxFree(dt_NR1);
			mxFree(Epara0);
			mxFree(sdt_NR);
			
			if(stepprint)mexPrintf("Free memory\n");
			
			for (j1 = 0; j1 < NZ; j1++) {
				for (j2 = 0; j2 < NLat; j2++) {
					Lamb[j1 + j2 * NZ] = Lamb0[j1 + j2 * NZ];
				}
				mu[j1] = mu0[j1];
				SIG[j1] = SIG0[j1];
			}
			
			for (j1 = 0; j1 < Npara; j1++) {
				para[j1] = para0[j1];
			}
			
			/* ***
			NR0 = (int) NR_ALL[jnr - 1];
			*/
			
			
			for (j3 = 0; j3 < NObs; j3++) {
				for (j2 = 0; j2 < N0_ALL[j3] + 1; j2++) {
					for (j1 = 0; j1 < NLat; j1++) {
						Y0[j2 + j3 * N01 + j1 * N01 * NObs] = YM0[j1 + j2 * NLat + j3 * NLat * N01];
					}
				}
			}
			
			for (j1 = 0; j1 < NObs; j1++) {
				for (j2 = 0; j2 < N0_ALL[j1] + 1; j2++) {
					for (j3 = 0; j3 < NLat; j3++) {
						/* ***
						Y[j1 * N10 * NLat + j2 * (NR0 + 1) * NLat + j3] = YM0[j1 * NLat * N01 + j2 * NLat + j3];
						*/
						Y[j1 * N10 * NLat + obsloc0[j1][j2] * NLat + j3] = YM0[j1 * NLat * N01 + j2 * NLat + j3];
					}
				}
				for (j2 = 0; j2 < N0_ALL[j1]; j2++) {
					/* ***
					for (j4 = 1; j4 <= NR0; j4++) {
					*/
					itmp = obsloc0[j1][j2] - obsloc0[j1][j2] - 1;
					for (j4 = 1; j4 <= itmp; j4++) {
						for (j3 = 0; j3 < NLat; j3++) {
							/*
							dtmp1 = Y[j1 * N10 * NLat + j2 * (NR0 + 1) * NLat + j3];
							dtmp2 = Y[j1 * N10 * NLat + (j2 + 1) * (NR0 + 1) * NLat + j3];
							Y[j1 * N10 * NLat + (j2 * (NR0 + 1) + j4) * NLat + j3] =
							dtmp1 + (dtmp2 - dtmp1) * j4 / (NR0 + 1);
							*/
							dtmp1 = Y[j1 * N10 * NLat + obsloc0[j1][j2] * NLat + j3];
							dtmp2 = Y[j1 * N10 * NLat + obsloc0[j1][j2+1] * NLat + j3];
							Y[j1 * N10 * NLat + (obsloc0[j1][j2] + j4) * NLat + j3] =
							dtmp1 + (dtmp2 - dtmp1) * j4 / (itmp + 1);
						}
					}
				}
			}
			
			
			Y1 = (double *) mxMalloc(sizeof(double) * N10 * NObs * NLat);
			vb_eqn_va(Y, Y1, N10 * NObs * NLat);
			mxFree(Y);
			Y = (double *) mxMalloc(sizeof(double) * N1 * NObs * NLat);
			
			XV1 = (double *) mxMalloc(sizeof(double) * N1m10 * NObs * NXV);
			vb_eqn_va(XV, XV1, N1m10 * NObs * NXV);
			mxFree(XV);
			XV = (double *) mxMalloc(sizeof(double) * N1m1 * NObs * NXV);
			
			/*
			Y_mrp_new = (double *) mxMalloc(sizeof(double) * NObs * ((NMRP + 1) * (N10 - 1) + 1) * NLat);
			Y_mrp = (double *) mxMalloc(sizeof(double) * NObs * ((NMRP + 1) * (N10 - 1) + 1) * NLat);
			*/
			/*
			* initial value of latent variables
			*/
			
			
			
			/*itmp = ((NMRP + 1) * (N10 - 1) + 1) * NLat;*/
			
			for (k1 = 0; k1 < NLat; k1++) {
				/*
				* interpolate the augmented latent variables in the new resolution Y NLat*N1*NObs
				*/
				for (i1 = 0; i1 < NObs; i1++) {
					/* *** 
					N1tmp = N0_ALL[i1] * (NR + 1) + 1;
					*/
					N1tmp = obsloc[i1][N0_ALL[i1]] + 1;
					
					/*
					* put the latent variables in the last resolution in the new resolution.
					*/
					for (j1 = 0, j2 = 0; j1 < N1tmp; j1 = j1 + 2, j2++) {
						dtmp = Y1[k1 + j2 * NLat + i1 * NLat * N10];
						
						Y[k1 + j1 * NLat + i1 * NLat * N1] = dtmp;
						
						/*Y_mrp[k1 + j2 * (NMRP + 1) * NLat + i1 * itmp] = dtmp;*/
					}
					
					for (j1 = 1; j1 < N1tmp; j1 = j1 + 2) {
						Y[k1 + j1 * NLat + i1 * NLat * N1] =
						(Y[k1 + (j1 - 1) * NLat + i1 * NLat * N1] + Y[k1 + (j1 + 1) * NLat + i1 * NLat * N1]) / 2;
					}
				}
			}
			
			if(stepprint)mexPrintf("Y translation\n");
			
			/*
			* initial value of latent variables END
			*/
			
			for (k1 = 0; k1 < NXV; k1++) {
				for (i1 = 0; i1 < NObs; i1++) {
					N1tmp = obsloc0[i1][N0_ALL[i1]];
					/*
					* put the latent variables in the last resolution in the new resolution.
					*/
					j1 = 0;
					for (j2 = 0; j2 < N1tmp; j2++) {												
						dtmp = XV1[k1 + j2 * NXV + i1 * NXV * N1m10];
						XV[k1 + j1 * NXV + i1 * NXV * N1m1] = dtmp;
						j1++;	
						XV[k1 + j1 * NXV + i1 * NXV * N1m1] = dtmp;
						j1++;	
					}					
				}
			}
			
			
			
			
			dt_NR1 = (double *) mxMalloc(sizeof(double) * (N10 - 1) * NObs);
			for (j1 = 0; j1 < NObs; j1++) {
				/* ***vb_eqn_va(dt_NR + j1 * (N10 - 1), dt_NR1 + j1 * (N10 - 1), N0_ALL[j1] * (NR0 + 1));*/
				vb_eqn_va(dt_NR + j1 * (N10 - 1), dt_NR1 + j1 * (N10 - 1), obsloc0[j1][N0_ALL[j1]]);
			}
			if(stepprint)mexPrintf("dt translation 1\n");
			/*
			* delta t in the old resolution
			*/
			mxFree(dt_NR);
			dt_NR = (double *) mxMalloc(sizeof(double) * (N1 - 1) * NObs);	    /* delta t in the new resolution */
			
			sdt_NR = (double *) mxMalloc(sizeof(double) * (N1) * NObs); /* delta t in the new resolution */
			
			if(stepprint)mexPrintf("dt translation 2\n");
			
			/*
			dt_mrp = (double *) mxMalloc(sizeof(double) * NObs * (NMRP + 1) * (N10 - 1));
			sdt_mrp = (double *) mxMalloc(sizeof(double) * NObs * ((NMRP + 1) * (N10 - 1) + 1));
			*/
			for (j3 = 0; j3 < NObs; j3++) {
				itmp1 = j3 * (N10 - 1);
				itmp2 = j3 * (N1 - 1);
				/* ***
				itmp = N0_ALL[j3] * (NR0 + 1);
				*/
				itmp = obsloc0[j3][N0_ALL[j3]];
				
				/*itmp3 = j3 * (NMRP + 1) * (N10 - 1);*/
				
				j2 = 0;
				for (j1 = 0; j1 < itmp; j1++) {
					dt_NR[itmp2 + j2] = dt_NR1[itmp1 + j1] / 2;
					j2++;
					dt_NR[itmp2 + j2] = dt_NR1[itmp1 + j1] / 2;
					j2++;
					
					/*
					dt_mrp[itmp3 + j1 * (NMRP + 1) + NMRP] = dt_NR1[itmp1 + j1] / 2;
					/*
					* length of the last augmented interval
					*/
					/*
					for (j4 = 0; j4 < NMRP; j4++) {
						dt_mrp[itmp3 + j1 * (NMRP + 1) + j4] = dt_NR1[itmp1 + j1] / (2 * NMRP);
					}
					/*
					* length of the 1st(0) to NMRP-th(NMRP-1)
					*/
				}
				/*
				* cumsum(dt_NR+j3*(N1-1),sdt_NR+j3*(N1),N1m1);
				*
				* cumsum(dt_mrp+j3*(NMRP+1)*(N10-1),sdt_mrp+j3*((NMRP+1)*(N10-1)+1),(NMRP+1)*(N10-1));
				*/
				
				/* ***
				cumsum(dt_NR + j3 * (N1 - 1), sdt_NR + j3 * (N1), N0_ALL[j3] * (NR + 1));
				*/
				cumsum(dt_NR + j3 * (N1 - 1), sdt_NR + j3 * (N1), obsloc[j3][N0_ALL[j3]]);
				
				/*cumsum(dt_mrp + j3 * (NMRP + 1) * (N10 - 1), sdt_mrp + j3 * ((NMRP + 1) * (N10 - 1) + 1),
					(NMRP + 1) * itmp);*/
			}
			if(stepprint)mexPrintf("dt translation\n");
			/*
			* dtmp=0; for (i1=0;i1<NObs;i1++) { itmp1=N0_ALL[i1]*(NR0+1);
			*
			* j1 = 1; for (j2=0 ; j2<itmp1 ; j2++) { itmp3 = j2 * (NMRP+1) + i1 * ((NMRP+1)*(N10-1)+1); itmp2 = itmp3
			* * NLat;
			*
			* for(j3 = 1 ; j3 < (NMRP+1) ; j3++) { Lindstrom_1step(Y_mrp + itmp2, sdt_mrp + itmp3, para, a, b,
			* mu_lind, P, K, L, SIGMA, SIGMA0, yv_new, alpha, &proptmp, j3, NLat, NMRP, FL, 1, 1, idum);
			* vb_eqn_va(yv_new , Y_mrp + itmp2 + j3 * NLat, NLat); dtmp+=proptmp; }
			*
			* k3=(i1*N1+j1)*NLat; vb_eqn_va(Y_mrp + itmp2 + NMRP*NLat, Y + k3, NLat); j1=j1+2; } } mexPrintf("Initial
			* Y_mrp have density: %f\n",dtmp);
			*/
			
			/*
			* MCMC samples of latent variables from the last resolution
			*/
			/*
			* EY0=dmatrix(0,Nrec-1,0,N10*NObs*NLat-1);
			*
			* for (j1=0;j1<Nrec;j1++) { for (j2=0;j2<NLat;j2++){ for (j3=0;j3<NObs;j3++){ itmp=N0_ALL[j3]*(NR0+1)+1;
			* for (j4=0;j4<itmp;j4++) { i1=j2+j4*NLat+j3*NLat*N10; EY0[j1][i1]=EY[j1][i1]; } } } }
			* free_dmatrix(EY,0,Nrec-1,0,N10*NObs*NLat-1);
			*
			* if (jnr<NNR-1) { EY=dmatrix(0,Nrec-1,0,N1*NLat*NObs-1); }
			*/
			
			Epara0 = (double *) mxMalloc(sizeof(double) * Nrec * Npara);	    /* MCMC samples of parameters from the
			* last resolution */
			vb_eqn_va(Epara, Epara0, Nrec * Npara);
			mxFree(Epara);
			Epara = (double *) mxMalloc(sizeof(double) * Nrec * Npara); /* MCMC samples of parameters to be obtained in
			* this resolution */
			
			for (j1 = 0; j1 < Nrec; j1++) {
				j3 = j1 * NLY;
				j4 = j1 * NZ;
				for (j2 = 0; j2 < NLY; j2++) {
					ELY0[j3 + j2] = ELY[j3 + j2];
				}
				for (j2 = 0; j2 < NZ; j2++) {
					EMU0[j4 + j2] = EMU[j4 + j2];
					EPSI0[j4 + j2] = EPSI[j4 + j2];
				}
			}
			for (j1 = 0; j1 < Npara; j1++) {
				tuna[j1] /= 2;
				para[j1] = para0[j1];
			}
			if(stepprint)mexPrintf("parameter translation\n");
		}
		
		
		ACCy1 = 0;
		for (mc = 0; mc < MCMAX; mc++) {
			
			mexPrintf("%d\n",mc);
			
			for (ithin = 0; ithin < nthin; ithin++) {
				
				if(stepprint)mexPrintf("Start of the iteration\n");
				if(stepprint)mexPrintf("Sampling latent processes\n");
				
				cr_ind = ran2(idum);
				if (((cr_ind <= MRMp && jnr > 0) || (jnr == 0))) {
					if (ran2(idum) <= bridgeprop) {	    /* &&mc0==1 */
						if (FL == 0) {
							if(stepprint)mexPrintf("Use Lindstrom NR\n");
							
							Lindstrom(Y, Y_new, Z, mu, Lamb, SIG, sdt_NR, para, alpha, X, XV, NX, NXV, NObs, N0_ALL, obsloc, N1,
								NLat, Npara, FL, ACCy, ACCy_bs, idum);
						} else {
							if(stepprint)mexPrintf("Use Lindstrom NR+2\n");
							
							Lindstrom_bound(Y, Y_new, Z, mu, Lamb, SIG, sdt_NR, para, alpha, X, XV, NX, NXV, NObs, N0_ALL, obsloc,
								N1, NLat, Npara, N01, NZ, FL, ACCy, ACCy_bs, idum);
							for (i1 = 0; i1 < NObs; i1++) {
								itmp1 = N0_ALL[i1] + 1;
								i2 = i1 * N1 * NLat;
								for (k1 = 1; k1 < itmp1; k1++) {
									/* *** 
									k2 = k1 * (NR + 1) * NLat;
									*/
									k2 = obsloc[i1][k1] * NLat;
									
									for (j1 = 0; j1 < NLat; j1++) {
										Y0[j1 * NAL0 + i1 * N01 + k1] = Y[i2 + k2 + j1];
									}
								}
							}
						}
						
						/*
						* void Lindstrom_bound(double *Y, double *Y_new, double *Z, double *mu, double *Lamb, double
						* *SIG, double *sdt_NR, double *para, double alpha, int NObs, int *N0_ALL, int NR, int N1, int
						* NLat, int Npara, int N01, int NZ, int FL, int *ACCy, long *idum)
						*/
					} else {
						
						/*
						* if(FL!=0){
						*/
						if (FL) {
							if(stepprint)mexPrintf("Use 1-step at observed time points\n");
							
							for (i1 = 0; i1 < NObs; i1++) {	    /* number of observation */
								itmp = N0_ALL[i1];
								itmp1 = itmp + 1;
								itmp2 = i1 * N1m1;
								Xcur = X + i1 * NX;
								
								XVcur0 = XV + i1 * N1m1 * NXV;
								
								for (k1 = 1; k1 < itmp1; k1++) {	/* number of time points, totally N01=N0+1,
									* not N0, the first one is known initial */
									i3 = i1 * N01 + k1; /* count in all observed */
									/* ***
									itmp4 = i1 * N1 + k1 * (NR + 1);
									*/
									itmp4 = i1 * N1 + obsloc[i1][k1];
									itmp3 = (itmp4) * NLat;
									
									for (j3 = 0; j3 < NZ; j3++) {
										Zvec[j3] = Z[j3 * NAL0 + i3] - mu[j3];
									}
									
									XVcur = XVcur0 + (obsloc[i1][k1]-1) * NXV;
									
									if (k1 < itmp) {
										Lindstrom_1step_obs(Y + itmp3 - NLat, sdt_NR + itmp4 - 1, para, a, b, mu_lind,
											P, K, L, SIGMA, SIGMA0, yv_new, alpha0, &logr_den, Xcur, XVcur,
											Zvec, Lamb, SIG, NZ, 1, NLat, NXV, 1, FL, 1, 1, idum);
									} else {
										Lindstrom_1step_obs_endpoint(Y + itmp3 - NLat, sdt_NR + itmp4 - 1, para, a, b,
											mu_lind, P, K, L, SIGMA, SIGMA0, yv_new, alpha0,
											&logr_den, Xcur, XVcur, Zvec, Lamb, SIG, NZ, 1, NLat, NXV, 1,
											FL, 1, 1, idum);
									}
									logr_num = dmvnorm_L(Y + itmp3, L, mu_lind, a, b, NLat, 1);
									/* ***
									k2 = k1 * (NR + 1); /* location of observed latent variables in all latent
									* variables (augmented included) */
									k2 = obsloc[i1][k1];
									k3 = (k2) * NLat + i1 * NLat * N1;
									
									for (j3 = 0; j3 < NZ; j3++) {
										dtmp = Z[j3 * NAL0 + i3] - mu[j3];	/* Z N01*NObs*NLat, reordered */
										dtmp1 = dtmp;
										for (j4 = 0; j4 < NLat; j4++) {
											dtmp1 -= Lamb[j3 + j4 * NZ] * yv_new[j4];
										}
										logr_num -= pow(dtmp1, 2) / (2 * SIG[j3]);
										dtmp2 = dtmp;
										for (j4 = 0; j4 < NLat; j4++) {
											dtmp2 -= Lamb[j3 + j4 * NZ] * Y0[j4 * NAL0 + i3];
										}
										logr_den -= pow(dtmp2, 2) / (2 * SIG[j3]);
									}
									
									for (j3 = 0; j3 < NLat; j3++) {	    /* Y NLat*N1*NObs */
										if (k1 != itmp) {	/* N0=N01-1 */
											XVcur1 = XV+i1*N1m1*NXV+k1*NXV;
											
											dtmp = dt_NR[k2 + itmp2] * diffu_funa(yv_new, para, Xcur, j3, dt_NR[k2 + itmp2],XVcur1);
											
											logr_num -= 0.5 * log(dtmp) + pow(Y[k3 + NLat + j3] - yv_new[j3] - drift_funa(yv_new, para, Xcur, j3,dt_NR[k2 + itmp2],XVcur1) * dt_NR[k2 + itmp2], 2) / (2 * dtmp);
											
											dtmp = dt_NR[k2 + itmp2] * diffu_funa(Y + k3, para, Xcur, j3,dt_NR[k2 + itmp2],XVcur1);
											
											logr_den -= 0.5 * log(dtmp) + pow(Y[k3 + NLat + j3] - Y[k3 + j3] - drift_funa(Y + k3, para, Xcur, j3,dt_NR[k2 + itmp2],XVcur1) * dt_NR[k2 + itmp2], 2) / (2 * dtmp);
										}
										if (k1 != 0) {
											XVcur1 = XV+i1*N1m1*NXV+(k1-1)*NXV;
											
											dtmp = dt_NR[k2 - 1 + itmp2] * diffu_funa(Y + k3 - NLat, para, Xcur, j3, dt_NR[k2 - 1 + itmp2],XVcur1);
											dtmp1 = Y[k3 - NLat + j3] + drift_funa(Y + k3 - NLat, para, Xcur, j3,dt_NR[k2 - 1 + itmp2],XVcur1) *
											dt_NR[k2 - 1 + itmp2];
											logr_num -= 0.5 * log(dtmp) + pow(yv_new[j3] - dtmp1, 2) / (2 * dtmp);
											logr_den -= 0.5 * log(dtmp) + pow(Y[k3 + j3] - dtmp1, 2) / (2 * dtmp);
										}	/* acturally the log is not necesary. */
									}
									
									r = exp(logr_num - logr_den);
									if (ran2(idum) <= r) {
										for (j2 = 0; j2 < NLat; j2++) {
											Y0[j2 * NAL0 + i3] = yv_new[j2];
											Y[k3 + j2] = yv_new[j2];
											ACCy[k3 + j2] += 1;
										}
									}
									
								} /*for (k1 = 1; k1 < itmp1; k1++) {*/
							}/*for (i1 = 0; i1 < NObs; i1++) */
						} /* if (FL) */
						
						
						/*
						* draw the interpolated latent variables
						*/
						if(stepprint)mexPrintf("Use 1-step at interpolated time points\n");
						for (i1 = 0; i1 < NObs; i1++) { /* number of observation */
							itmp = N0_ALL[i1];
							/*
							* itmp1=itmp+1;
							*/
							itmp2 = i1 * N1m1;
							Xcur = X + i1 * NX;
							XVcur0 = XV + i1 * N0 * NXV;
							for (k1 = 0; k1 < itmp; k1++) {	    /* number of time points, totally N01=N0+1, not N0,
								* the first one is known initial */
								/* ***
								for (k4 = 1; k4 <= NR; k4++) {
								*/
								
								for (k2 = obsloc[i1][k1]+1; k2 < obsloc[i1][k1+1]; k2++) {
									/* location of observed latent variables in all latent
									* variables (augmented included) */
									/* ***
									k2 = k1 * (NR + 1) + k4;    
									itmp4 = i1 * N1 + k1 * (NR + 1) + k4;
									*/
									itmp4 = i1 * N1 + k2;
									itmp3 = itmp4 * NLat;
									
									XVcur = XVcur0 + (k2-1) * NXV;
									
									Lindstrom_1step(Y + itmp3 - NLat, sdt_NR + itmp4 - 1, para, a, b, mu_lind, P, K, L,
										SIGMA, SIGMA0, yv_new, alpha0, &logr_den, Xcur, XVcur, 1, NLat, NXV, 1, FL, 1,
										1, idum);
									
									logr_num = dmvnorm_L(Y + itmp3, L, mu_lind, a, b, NLat, 1);
									
									/*k2 = k1 * (NR + 1) + k4;    /* location of observed latent variables in all latent
									* variables (augmented included) */
									k3 = (k2 + i1 * N1) * NLat;
									
									for (j3 = 0; j3 < NLat; j3++) {	    /* Y NLat*N1*NObs */
										
										XVcur1 = XV+i1*N1m1*NXV+k2*NXV;
										dtcur1 = dt_NR[k2 + itmp2];
										
										dtmp1 = diffu_funa(yv_new, para, Xcur, j3, dtcur1,XVcur1);
										logr_num -= 0.5 * log(dtcur1 * dtmp1) + pow(Y[k3 + NLat + j3] - yv_new[j3] - drift_funa(yv_new, para, Xcur, j3, dtcur1,XVcur1) * dtcur1,2) / (2 * dtcur1 * dtmp1);
										
										dtmp2 = diffu_funa(Y + k3, para, Xcur, j3,dtcur1,XVcur1);
										logr_den -= 0.5 * log(dtcur1 * dtmp2) + pow(Y[k3 + NLat + j3] - Y[k3 + j3] - drift_funa(Y + k3, para, Xcur, j3, dtcur1,XVcur1) * dtcur1, 2) / (2 * dtcur1 * dtmp2);
										
										
										XVcur1 = XV+i1*N1m1*NXV+(k2-1)*NXV;
										dtcur1 = dt_NR[k2 - 1 + itmp2];
										
										dtmp = 0.5 * log(dtcur1 * diffu_funa(Y + k3 - NLat, para, Xcur, j3,dtcur1,XVcur1));
										
										dtmp1 =	Y[k3 - NLat + j3] + drift_funa(Y + k3 - NLat, para, Xcur, j3, dtcur1,XVcur1) * dtcur1;
										dtmp2 = 2 * dtcur1 * diffu_funa(Y + k3 - NLat, para, Xcur, j3,dtcur1,XVcur1);
												
										logr_num -= dtmp + pow(yv_new[j3] - dtmp1, 2) / dtmp2;
												
										logr_den -= dtmp + pow(Y[k3 + j3] - dtmp1, 2) / dtmp2;
										/* acturally the log is not necesary.	*/
									}
									
									r = exp(logr_num - logr_den);
									if (ran2(idum) <= r) {
										for (j2 = 0; j2 < NLat; j2++) {
											Y[k3 + j2] = yv_new[j2];
											ACCy[k3 + j2] += 1;
										}
									}
								}
							}
						}
					}	    /* if (ran2(idum) <= bridgeprop) else */
					
					/*
					* draw mu, N0 remains the same throught different resolutions
					*/
					if(stepprint)mexPrintf("draw mu\n");
					
					newmu(N, NObs, N01, N0_ALL, NZ, NLat, Y0, Lamb, mu_new, Pmu, SIG, Z, Imu, idum);
					mu[1] = mu_new[1]; mu[2] = mu_new[2];
					
					/*
					* draw Lambda and psi in a block
					*/
					if(stepprint)mexPrintf("draw Lambda and psi\n");
					
					for (j1 = 0; j1 < NZ; j1++) {
						dtmp = 0;
						itmp = j1 * NAL0;
						for (j2 = 0; j2 < NObs; j2++) {
							itmp2 = N0_ALL[j2] + 1;
							itmp1 = j2 * N01;
							for (j3 = 0; j3 < itmp2; j3++) {
								j4 = j3 + itmp1;
								dtmp = Z[j4 + itmp] - mu[j1];
								for (k1 = 0; k1 < NLat; k1++) {
									if (ILamb[j1 + k1 * NZ] == 0) {
										dtmp -= Lamb[j1 + k1 * NZ] * Y0[k1 * NAL0 + j4];
									}
								}
								Zc[j4] = dtmp;
							}
						}
						newsy(j1, N, NObs, N01, N01_ALL, NZ, NFLamb[j1], SIGI[j1], LFLamb, Y0, Lamb, Zc, PMLamb,
							PSLamb, SIG, PSIG, idum);
					}	/* Y0 ((N0+1)*NObs*NLat) */
					
					if(jnr==0&&mc<=Nburn){
						para_samp_prob=1;	
					}else{
						para_samp_prob=1;	
					}
					
					
					
					/*if(gsl_rng_uniform(rgsl)<=para_samp_prob){*/
					/*if(ran2(idum)<=para_samp_prob){*/
					for(j1=0;j1<5;j1++){
						if(1){
							if(stepprint)printf("Random walk MH 1 starts\n");
							/*
							int RWMH2(double *z, double *x, double *dt, double *parac0, double *param, double *paraCSig, double *p1, double *p2, double *priortype, int df, int Npara, int NObs, int N0, int NR, int *N0_ALL, int NX, int NLat, gsl_rng *r, int *idx, int nidx, double mtis, double *constr_mat, int constr_mat_dim1, int *ineq_flag, double *a, int nmtm)
							*/
							mhidx[0] = 0;mhidx[1] = 1;mhidx[2] = 2;mhidx[3] = 3;mhidx[4] = 4;
							mhidx[5] = 5;mhidx[6] = 6;
							itmp = 0;
							/*for(j1=0;j1<10;j1++){*/
							itmp += RWMH2(Y, X, XV, dt_NR, para, IMHEmpara, IMHCCovpara, p1, p2, ptype, 3, Npara, NObs, N1, obsloc, N0_ALL, NX, NXV, NLat, rgsl, mhidx,nidx1,0.5,constr_mat1,Ncon1,ineq_flag1,constr_a1,1);
							/*}*/
							if(itmp>0){
								itmp = 1;	
							}else{
								itmp = 0;	
							}
							ACC_dyn_mh[0] += itmp;
							if(stepprint)printf("Random walk MH 1 finishes\n");
						}
						
						
						if(1){
							if(stepprint)printf("Random walk MH 2 starts\n");
							/*
							int RWMH2(double *z, double *x, double *dt, double *parac0, double *param, double *paraCSig, double *p1, double *p2, double *priortype, int df, int Npara, int NObs, int N0, int NR, int *N0_ALL, int NX, int NLat, gsl_rng *r, int *idx, int nidx, double mtis, double *constr_mat, int constr_mat_dim1, int *ineq_flag, double *a, int nmtm)
							*/
							
							mhidx[0] = 7;mhidx[1] = 8;mhidx[2] = 9;mhidx[3] = 10;mhidx[4] = 11;
							mhidx[5] = 12;mhidx[6] = 13;
							
							itmp = 0;
							/*for(j1=0;j1<10;j1++){*/
							itmp += RWMH2(Y, X, XV, dt_NR, para, IMHEmpara, IMHCCovpara, p1, p2, ptype, 3, Npara, NObs, N1, obsloc, N0_ALL, NX, NXV, NLat, rgsl, mhidx,nidx2,5,constr_mat2,Ncon2,ineq_flag2,constr_a2,1);
							/*}*/
							if(itmp>0){
								itmp = 1;	
							}else{
								itmp = 0;	
							}
							ACC_dyn_mh[1] += itmp;
							if(stepprint)printf("Random walk MH 2 finishes\n");
						}
						
						if(1){
							if(stepprint)printf("Random walk MH 3 starts\n");
							/*
							int RWMH2(double *z, double *x, double *dt, double *parac0, double *param, double *paraCSig, double *p1, double *p2, double *priortype, int df, int Npara, int NObs, int N0, int NR, int *N0_ALL, int NX, int NLat, gsl_rng *r, int *idx, int nidx, double mtis, double *constr_mat, int constr_mat_dim1, int *ineq_flag, double *a, int nmtm)
							*/
							mhidx[0] = 14;mhidx[1] = 15;mhidx[2] = 16;mhidx[3] = 17;mhidx[4] = 18;
							mhidx[5] = 19;mhidx[6] = 20;
							itmp = 0;
							/*for(j1=0;j1<10;j1++){*/
							itmp += RWMH2(Y, X, XV, dt_NR, para, IMHEmpara, IMHCCovpara, p1, p2, ptype, 3, Npara, NObs, N1, obsloc, N0_ALL, NX, NXV, NLat, rgsl, mhidx,nidx3,0.5,constr_mat3,Ncon3,ineq_flag3,constr_a3,1);
							/*}*/
							if(itmp>0){
								itmp = 1;	
							}else{
								itmp = 0;	
							}
							ACC_dyn_mh[2] += itmp;
							if(stepprint)printf("Random walk MH 3 finishes\n");
						}
						
						if(1){
							if(stepprint)printf("Random walk MH 4 starts\n");
							/*
							int RWMH2(double *z, double *x, double *dt, double *parac0, double *param, double *paraCSig, double *p1, double *p2, double *priortype, int df, int Npara, int NObs, int N0, int NR, int *N0_ALL, int NX, int NLat, gsl_rng *r, int *idx, int nidx, double mtis, double *constr_mat, int constr_mat_dim1, int *ineq_flag, double *a, int nmtm)
							*/
							mhidx[0] = 21;mhidx[1] = 22;mhidx[2] = 23;mhidx[3] = 24;mhidx[4] = 25;
							mhidx[5] = 26;mhidx[6] = 27;
							/*for(j1=0;j1<10;j1++){*/
							itmp += RWMH2(Y, X, XV, dt_NR, para, IMHEmpara, IMHCCovpara, p1, p2, ptype, 3, Npara, NObs, N1, obsloc, N0_ALL, NX, NXV, NLat, rgsl, 
							mhidx,nidx4,0.5,constr_mat4,Ncon4,ineq_flag4,constr_a4,1);
							/*}*/
							if(itmp>0){
								itmp = 1;	
							}else{
								itmp = 0;	
							}
							ACC_dyn_mh[3] += itmp;
							if(stepprint)printf("Random walk MH 4 finishes\n");
						}
						
						if(1){
							if(stepprint)printf("Random walk MH 5 starts\n");
							/*
							int RWMH2(double *z, double *x, double *dt, double *parac0, double *param, double *paraCSig, double *p1, double *p2, double *priortype, int df, int Npara, int NObs, int N0, int NR, int *N0_ALL, int NX, int NLat, gsl_rng *r, int *idx, int nidx, double mtis, double *constr_mat, int constr_mat_dim1, int *ineq_flag, double *a, int nmtm)
							*/
							mhidx[0] = 28;mhidx[1] = 29;mhidx[2] = 30;mhidx[3] = 31;mhidx[4] = 32;
							mhidx[5] = 33;mhidx[6] = 34;
							itmp = 0;
							/*for(j1=0;j1<10;j1++){*/
							itmp += RWMH2(Y, X, XV, dt_NR, para, IMHEmpara, IMHCCovpara, p1, p2, ptype, 3, Npara, NObs, N1, obsloc, N0_ALL, NX, NXV, NLat, rgsl, 
							mhidx,nidx5,5,constr_mat5,Ncon5,ineq_flag5,constr_a5,1);
							/*}*/
							if(itmp>0){
								itmp = 1;	
							}else{
								itmp = 0;	
							}
							ACC_dyn_mh[4] += itmp;
							if(stepprint)printf("Random walk MH 5 finishes\n");
						}
						
						if(1){
							if(stepprint)printf("Random walk MH 6 starts\n");
							/*
							int RWMH2(double *z, double *x, double *dt, double *parac0, double *param, double *paraCSig, double *p1, double *p2, double *priortype, int df, int Npara, int NObs, int N0, int NR, int *N0_ALL, int NX, int NLat, gsl_rng *r, int *idx, int nidx, double mtis, double *constr_mat, int constr_mat_dim1, int *ineq_flag, double *a, int nmtm)
							*/
							mhidx[0] = 35;mhidx[1] = 36;mhidx[2] = 37;mhidx[3] = 38;mhidx[4] = 39;
							mhidx[5] = 40;mhidx[6] = 41;
							itmp = 0;
							/*for(j1=0;j1<10;j1++){*/
							itmp += RWMH2(Y, X, XV, dt_NR, para, IMHEmpara, IMHCCovpara, p1, p2, ptype, 3, Npara, NObs, N1, obsloc, N0_ALL, NX, NXV, NLat, rgsl, 
							mhidx,nidx6,5,constr_mat6,Ncon6,ineq_flag6,constr_a6,1);
							/*}*/
							if(itmp>0){
								itmp = 1;	
							}else{
								itmp = 0;	
							}
							ACC_dyn_mh[5] += itmp;
							if(stepprint)printf("Random walk MH 6 finishes\n");
						}
						
						if(1){
							if(stepprint)printf("Random walk MH 7 starts\n");
							/*
							int RWMH2(double *z, double *x, double *dt, double *parac0, double *param, double *paraCSig, double *p1, double *p2, double *priortype, int df, int Npara, int NObs, int N0, int NR, int *N0_ALL, int NX, int NLat, gsl_rng *r, int *idx, int nidx, double mtis, double *constr_mat, int constr_mat_dim1, int *ineq_flag, double *a, int nmtm)
							*/
							mhidx[0] = 42;mhidx[1]=7;mhidx[2]=28;
							itmp = 0;
							/*for(j1=0;j1<10;j1++){*/
							itmp += RWMH2(Y, X, XV, dt_NR, para, IMHEmpara, IMHCCovpara, p1, p2, ptype, 3, Npara, NObs, N1, obsloc, N0_ALL, NX, NXV, NLat, rgsl, 
							mhidx,nidx7,5,constr_mat7,Ncon7,ineq_flag7,constr_a7,1);
							/*}*/
							if(itmp>0){
								itmp = 1;	
							}else{
								itmp = 0;	
							}
							ACC_dyn_mh[6] += itmp;
							if(stepprint)printf("Random walk MH 7 finishes\n");
						}
					}
										
					mexPrintf("Parameters:\n");
					for(i1=0;i1<Npara;i1++){
						mexPrintf("%f ",para[i1]);
					}
					mexPrintf("\n");
					
					/*
					* dynyx4(Y,Y_new,DX_new,dt_NR, X, para, NObs,N0_ALL,N0,NR,NLat,3); DYPSI[3]=para[4]; j1=3;
					* newsy2(j1, N1m1sum, NObs, N1m1, N1m1_ALL, NYdyn, ROWdyn[j1], DYPSIIND[j1], CLMdyn, DX_new,
					* DYLY, Y_new, PLYdyn, PSLYdyn, DYPSI, DYPPSI,idum); para[5]=DYLY[3];
					*/
					
					
					/*
					* para[6]=DYLY[7]; para[7]=DYLY[11];
					*/
					
					/*
					* update Y_mrp
					*/
					/*
					* if(jnr>0){ for (i1=0;i1<NObs;i1++) { itmp1=N0_ALL[i1]*(NR0+1);
					*
					* for (j2=0 ; j2<itmp1 ; j2++) { itmp3 = j2 * (NMRP+1) + i1 * ((NMRP+1)*(N10-1)+1); itmp2 =
					* itmp3 * NLat;
					*
					* for(j3 = 1 ; j3 < NMRP ; j3++) { Lindstrom_1step(Y_mrp + itmp2, sdt_mrp + itmp3, para, a,
					* b, mu_lind, P, K, L, SIGMA, SIGMA0, yv_new, alpha, &proptmp, j3, NLat, NMRP-1, FL, 1, 0,
					* idum); vb_eqn_va(yv_new, Y_mrp + itmp2 + j3 * NLat, NLat); } } } }
					*/
				} else { /* move in the same resolution */
					
					if(stepprint)mexPrintf("Cross resolution move\n");
					
					empi = (int) floor(ran2(idum) * Nrec);
					if (empi == Nrec)
						empi = Nrec - 1;
					/*
					* mexPrintf("mc=%d,empi=%d\n",mc,empi);
					*/
					/*
					* k1=empi*NLat*N10*NObs;
					*/
					
					/*
					* sample from empirical distribution
					*/
					j1 = sprintf(buffer, "EY/EY_%d_%d.txt", jnr - 1, empi);
					dat = fopen(buffer, "r");
					if (dat == NULL) {
						mexPrintf("File error in EY reading!\n");
						exit(1);
					}
					
					for (i1 = 0; i1 < NObs; i1++) {
						
						j2 = 0;
						i2 = i1 * NLat * N1;
						i3 = i1 * NLat * N10;
						/* ***
						N1tmp = N0_ALL[i1] * (NR + 1) + 1;
						*/
						N1tmp =  obsloc[i1][N0_ALL[i1]] + 1;
						for (j1 = 0; j1 < N1tmp; j1 = j1 + 2) {
							j3 = j1 * NLat;
							
							j4 = j2 * NLat;
							for (k3 = 0; k3 < NLat; k3++) {
								fscanf(dat, "%f", &ftmp);
								dtmp = (double) ftmp;
								Y_new[i2 + j3 + k3] = dtmp;
								Y1[i3 + j4 + k3] = dtmp;
								Y2[i3 + j4 + k3] = Y[i2 + j3 + k3];
							}
							j2++;
						}
					}
					
					fclose(dat);
					
					j2 = empi * Npara;
					for (j1 = 0; j1 < Npara; j1++) {
						para_new[j1] = Epara0[j2 + j1];
					}
					
					j2 = 0;
					mcab1 = empi * NZ;
					mcab2 = empi * NLY;
					for (j1 = 0; j1 < NZ; j1++) {
						for (j3 = 0; j3 < NLat; j3++) {
							Lamb_new[j1 + j3 * NZ] = Lamb[j1 + j3 * NZ];
						}
						for (j3 = 0; j3 < NFLamb[j1]; j3++) {
							j4 = LFLamb[j1 + j3 * NZ];
							Lamb_new[j1 + j4 * NZ] = ELY0[mcab2 + j2];
							j2++;
						}
						mu_new[j1] = EMU0[mcab1 + j1];
						SIG_new[j1] = EPSI0[mcab1 + j1];
					}
					
					pi_trial_k = 0;
					pi_old_k = 0;
					/*
					* proposal density of the coerce grid based on empirical density of last grids
					*/
					for (j1 = 0; j1 < NObs; j1++) {
						
						itmp2 = j1 * (N10 - 1);
						/* ***
						itmp = N0_ALL[j1] * (NR0 + 1);
						*/
						/*itmp = obsloc0[j1][N0_ALL[j1]];*/
						Xcur = X + j1 * NX;
						/*for (j2 = 0; j2 < itmp; j2++) {*/
						
							
						itmp = N0_ALL[j1];
						for (j5 = 0; j5 < itmp; j5++) {	    /* number of time points, totally N01=N0+1, not N0, the first one is known initial */
							for (j2 = obsloc0[j1][j5]; j2 < obsloc0[j1][j5+1]; j2++) {	
							
							
							k1 = (j1 * N10 + j2) * NLat;
							j4 = j2 + itmp2;
							for (j3 = 0; j3 < NLat; j3++) {
								/*
								* k2=j2+1;
								*/
								
								XVcur1 = XV1+j1*N1m10*NXV+j2*NXV;
								
								dtmp = dt_NR1[j4] * diffu_funa(Y1 + k1, para_new, Xcur, j3, dt_NR1[j4],XVcur1);
								pi_trial_k -= log(dtmp) + pow(Y1[k1 + NLat + j3] - Y1[k1 + j3] - drift_funa(Y1 + k1, para_new, Xcur, j3, dt_NR1[j4],XVcur1) * dt_NR1[j4], 2) / (dtmp);
								
								dtmp = dt_NR1[j4] * diffu_funa(Y2 + k1, para, Xcur, j3,dt_NR1[j4],XVcur1);
								pi_old_k -= log(dtmp) + pow(Y2[k1 + NLat + j3] - Y2[k1 + j3] - drift_funa(Y2 + k1, para, Xcur, j3, dt_NR1[j4],XVcur1) * dt_NR1[j4], 2) / (dtmp);
							}
						}
						}
					}
					
					pi_trial_k *= 0.5;
					pi_old_k *= 0.5;
					
					/*
					* generate and calculate the proposal density of added grid in finer grids
					*/
					tau_old_2kp1 = 0;
					tau_trial_2kp1 = 0;
					
					for (k1 = 0; k1 < NObs; k1++) {
						
						itmp2 = k1 * N1m1;
						/* ***
						N1tmp = N0_ALL[k1] * (NR + 1) + 1;
						*/
						/*N1tmp =  obsloc[k1][N0_ALL[k1]] + 1;*/
						
						Xcur = X + k1 * NX;
						
						XVcur0 = XV + k1 * N1m1 * NXV;
						
						/*for (j1 = 1; j1 < N1tmp; j1 = j1 + 2) {*/
						itmp = N0_ALL[k1];
						for (j5 = 0; j5 < itmp; j5++) {	    /* number of time points, totally N01=N0+1, not N0, the first one is known initial */
							for (j1 = obsloc[k1][j5]+1; j1 < obsloc[k1][j5+1]; j1=j1+2) {	
							
						
							
							j2 = j1 - 1;
							
							k3 = (k1 * N1 + j1) * NLat;
							j4 = j2 + itmp2;
							
							XVcur = XVcur0 + j2 * NXV;
							
							for (k2 = 0; k2 < NLat; k2++) {
								low = yrange[0 * NLat + k2];
								upp = yrange[1 * NLat + k2];
								
								Lindstrom_1step(Y_new + k3 - NLat, sdt_NR + k1 * N1 + j1 - 1, para_new, a, b, mu_lind,
									P, K, L, SIGMA, SIGMA0, yv_new, alpha0, &dtmp, Xcur, XVcur, 1, NLat, NXV, 1, FL, 1,
									1, idum);
								vb_eqn_va(yv_new, Y_new + k3, NLat);
								tau_trial_2kp1 += dtmp;
								
								/*
								* normalizing constant added
								*/
								
								/*
								* normp(low1,&dtmp1,&dtmp,&dtmp3); normp(upp1,&dtmp2,&dtmp,&dtmp3);
								* dtmp=log(dtmp2-dtmp1);
								*/
								Lindstrom_1step(Y + k3 - NLat, sdt_NR + k1 * N1 + j1 - 1, para, a, b, mu_lind, P, K, L,
									SIGMA, SIGMA0, yv_new, alpha0, &dtmp, Xcur, XVcur, 1, NLat, NXV, 1, FL, 0, 1, idum);
								tau_old_2kp1 += dtmp;
								/*
								* tau_old_2kp1-=pow(Y[k3+k2]-ymean, 2)/yvar; tau_old_2kp1-=log(yvar);
								* tau_old_2kp1-=dtmp; tau_old_2kp1-=dtmp;
								*/
							}
							}
						}
					}
					/*
					* tau_old_2kp1*=0.5; tau_trial_2kp1*=0.5;
					*//*
					* included in yint_prop_logden
					*/
					
					/*
					* target density of all grids
					*/
					pi_trial_2kp1 = 0;
					pi_old_2kp1 = 0;
					for (k1 = 0; k1 < NObs; k1++) {
						
						/*
						* dynamic equation part.
						*/
						itmp2 = k1 * N1m1;
						/* ***
						N1tmp = N0_ALL[k1] * (NR + 1) + 1;
						*/
						/*N1tmp =  obsloc[k1][N0_ALL[k1]] + 1;*/
						
						Xcur = X + k1 * NX;
						/*for (j1 = 1; j1 < N1tmp; j1++){*/
							
						itmp = N0_ALL[k1];
						for (j5 = 0; j5 < itmp; j5++) {	    /* number of time points, totally N01=N0+1, not N0, the first one is known initial */
							for (j1 = obsloc[k1][j5]; j1 < obsloc[k1][j5+1]; j1++) {
							
							/*j2 = j1 + 1;*/
							k3 = (k1 * N1 + j1) * NLat;
							k4 = k3 + NLat;
							
							j4 = itmp2 + j1;
							for (k2 = 0; k2 < NLat; k2++) {
								XVcur1 = XV+k1*N1m1*NXV+j1*NXV;
								
								dtmp = dt_NR[j4] * diffu_funa(Y_new + k3, para_new, Xcur, k2,dt_NR[j4],XVcur1);
								pi_trial_2kp1 -= log(dtmp);
								
								pi_trial_2kp1 -=pow(Y_new[k4 + k2] - Y_new[k3 + k2] - drift_funa(Y_new + k3, para_new, Xcur, k2, dt_NR[j4],XVcur1) * dt_NR[j4], 2) / (dtmp);
									
								dtmp = dt_NR[j4] * diffu_funa(Y + k3, para, Xcur, k2,dt_NR[j4],XVcur1);
								pi_old_2kp1 -= log(dtmp);
									
								pi_old_2kp1 -= pow(Y[k4 + k2] - Y[k3 + k2] - drift_funa(Y + k3, para, Xcur, k2, dt_NR[j4],XVcur1) * dt_NR[j4], 2) / (dtmp);
								/* when the range of Y is not R, normalizing constants are also need here.*/
							}
						}
						}
						
						/*
						* measurement equation part.
						*/
						/*
						* k2=k1*N01;
						*
						*
						* k3=k1*N1*NLat; for (i1=0;i1<NZ;i1++) { i2=i1*N01*NObs; for (j1=0;j1<N01;j1=j1++)
						*
						* { dtmp=Z[j1+k2+i2];//Z N01*NObs*NLat, reordered dtmp1=dtmp-mu_new[i1]; dtmp2=dtmp-mu[i1];
						* j2=j1*(NR+1)*NLat; for (i3=0;i3<NLat;i3++) {
						*
						* dtmp1-=Lamb_new[i1+i3*NZ]*Y_new[i3+j2+k3]; dtmp2-=Lamb[i1+i3*NZ]*Y[i3+j2+k3]; }
						* pi_trial_2kp1-=pow(dtmp1,2)/(SIG_new[i1])+log(SIG_new[i1]);
						* pi_old_2kp1-=pow(dtmp2,2)/(SIG[i1])+log(SIG[i1]); } }
						*/
					}
					
					
					pi_trial_2kp1 *= 0.5;
					pi_old_2kp1 *= 0.5;
					
					r = pi_trial_2kp1 + pi_old_k + tau_old_2kp1 - pi_old_2kp1 - pi_trial_k - tau_trial_2kp1;
					
					
					dat = fopen("tmpp.txt", "a");
					fprintf(dat, "%f,%f, %f,%f, %f,%f, %f, %f, %f, %f\n", pi_trial_2kp1, pi_old_k, tau_old_2kp1,
						pi_old_2kp1, pi_trial_k, tau_trial_2kp1, r, pi_trial_2kp1 - pi_old_2kp1,
						pi_old_k - pi_trial_k, tau_old_2kp1 - tau_trial_2kp1);
					fclose(dat);
					
					dtmp1 = exp(r);
					dtmp2 = ran2(idum);
					mexPrintf("CR ration:%f, cut: %f\n",dtmp1,dtmp2);
					if (dtmp2 <= dtmp1) {
						for (j3 = 0; j3 < NObs; j3++) {
							k3 = j3 * N1 * NLat;
							/*
							N1tmp = N0_ALL[j3] * (NR + 1) + 1;
							*/
							N1tmp =  obsloc[j3][N0_ALL[j3]] + 1;
							
							for (j1 = 0; j1 < N1tmp; j1++) {
								j2 = j1 * NLat;
								for (i1 = 0; i1 < NLat; i1++) {
									Y[k3 + j2 + i1] = Y_new[k3 + j2 + i1];
								}
								
							}
							itmp = N0_ALL[j3] + 1;
							for (j1 = 0; j1 < itmp; j1++) {
								/*
								j2 = j1 * (NR + 1);
								*/
								j2 = obsloc[j3][j1];
								for (i1 = 0; i1 < NLat; i1++) {
									Y0[i1 * NAL0 + j3 * N01 + j1] = Y[k3 + j2 * NLat + i1];
								}
							}
						}
						for (j3 = 0; j3 < Npara; j3++) {
							para[j3] = para_new[j3];
						}
						
						for (j1 = 0; j1 < NZ; j1++) {
							for (j3 = 0; j3 < NLat; j3++) {
								Lamb[j1 + j3 * NZ] = Lamb_new[j1 + j3 * NZ];
							}
							mu[j1] = mu_new[j1];
							SIG[j1] = SIG_new[j1];
						}
						ACCy1 += 1;
					}
				}
			}
			
			/*
			* mexPrintf("mc=%d\n",mc);
			*/
			mcab = mc - Nburn;
			if (mcab >= 0) {
				/*
				* mexPrintf("begin record ");
				*/
				j1 = mcab * Npara;
				for (j2 = 0; j2 < Npara; j2++) {
					Epara[j1 + j2] = para[j2];
				}
				/*
				* mexPrintf("record Epara ");
				*/
				
				/*
				* j1=NLat*N1*NObs; mcab1=mcab*j1;
				*/
				if (1) {	    /* jnr<NNR-1 */
					j1 = sprintf(buffer, "EY/EY_%d_%d.txt", jnr, mcab);
					dat = fopen(buffer, "w");
					if (dat == NULL) {
						mexPrintf("File error in EY writing!\n");
						exit(2);
					}
					
					for (j1 = 0; j1 < NObs; j1++) {
						/* ***
						itmp = N0_ALL[j1] * (NR + 1) + 1;
						*/
						itmp = obsloc[j1][N0_ALL[j1]] + 1;
						for (j2 = 0; j2 < itmp; j2++) {
							for (j3 = 0; j3 < NLat; j3++) {
								/*
								* j4=j3+j2*NLat+j1*N1*NLat; EY[mcab][j4]=Y[j4];
								*/
								fprintf(dat, "%f ", Y[j3 + j2 * NLat + j1 * N1 * NLat]);
							}
						}
					}
					fclose(dat);
					/*
					* mexPrintf("record EY ");
					*/
				}
				
				mcab1 = mcab * NZ;
				mcab2 = mcab * NLY;
				j2 = 0;
				for (j1 = 0; j1 < NZ; j1++) {
					for (j3 = 0; j3 < NFLamb[j1]; j3++) {
						j4 = LFLamb[j1 + j3 * NZ];
						ELY[mcab2 + j2] = Lamb[j1 + j4 * NZ];
						j2++;
					}
					EMU[mcab1 + j1] = mu[j1];
					EPSI[mcab1 + j1] = SIG[j1];
				}
				/*
				* mexPrintf("record finish\n");
				*/
			}
			
			if(jnr==0&&mcab<0){
				j1 = mc * Npara;
				for (j2 = 0; j2 < Npara; j2++) {
					Epara[j1 + j2] = para[j2];
				}
				if(mcab==-1){
					/*Cal_MCmean_cov_colwise(Epara+(Nburn/2)*Npara,Nburn/2,Npara,IMHEmpara,IMHCovpara);*/
					/*
					Cal_MCmean_cov_colwise(Epara,Nburn,Npara,IMHEmpara,IMHCovpara);
					band_choldc_c(IMHCovpara, IMHCCovpara, &Npara, &Npara);
					for(j1=0;j1<Npara;j1++){
						for(j2=0;j2<Npara;j2++){
							IMHCCovpara[j1+j2*Npara] /= imhfactor;
						}
					}
					printmatrix(IMHCCovpara,Npara,Npara);
					printmatrix(IMHEmpara,Npara,1);
					*/
				}
			}
			
			
			if (mc % 100 == 0) {
				/* check for a Ctrl-C event */
				/*
				if (utIsInterruptPending()) {        
					mexPrintf("Ctrl-C Detected. END\n\n");
					return;
				}
				*/
				
				/*
				* print to screen
				*/
				for (j1 = 0; j1 < Npara; j1++) {
					mexPrintf("%f ", para[j1]);
				}
				mexPrintf("\n");
				for (j1 = 0; j1 < Npara; j1++) {
					mexPrintf("%d ", ACCP[j1]);
				}
				mexPrintf("\n");
				mexPrintf("%d\n", mc);
				
				/*
				* print to files
				*/
				j1 = sprintf(buffer, "ACCP%d.txt", jnr);
				dat = fopen(buffer, "w");
				for (j2 = 0; j2 < Npara; j2++) {
					fprintf(dat, "%d ", ACCP[j2]);
				}
				fprintf(dat, "\n");
				fclose(dat);
				
				j1 = sprintf(buffer, "ACCy%d.txt", jnr);
				dat = fopen(buffer, "w");
				itmp = N1 * NObs * NLat;
				for (j2 = 0; j2 < itmp; j2++) {
					fprintf(dat, "%d ", ACCy[j2]);
					fprintf(dat, "\n");
				}
				fclose(dat);
				
				j1 = sprintf(buffer, "Epara%d.txt", jnr);
				dat = fopen(buffer, "w");
				k2 = 0;
				for (k1 = 0; k1 <= mcab; k1++) {
					for (j2 = 0; j2 < Npara; j2++) {
						fprintf(dat, "%8.5f ", Epara[k2]);
						k2++;
					}
					fprintf(dat, "\n");
				}
				fclose(dat);
				
				j1 = sprintf(buffer, "ACC_CR.txt");
				dat = fopen(buffer, "a");
				fprintf(dat, "NR=%d, ACC=%d", jnr, ACCy1);
				fprintf(dat, "\n");
				fclose(dat);
				
				j1 = sprintf(buffer, "ACC_bet_mh.txt");
				dat = fopen(buffer, "a");
				fprintf(dat, "NR=%d, ACC=%d, %d, %d, %d, %d, %d, %d\n", jnr, ACC_dyn_mh[0],ACC_dyn_mh[1],ACC_dyn_mh[2],ACC_dyn_mh[3],ACC_dyn_mh[4],ACC_dyn_mh[5],ACC_dyn_mh[6]);
				fclose(dat);
				
			}
			/*
			* if (mc%100==0)
			*/
		}			    /* mc */
		
		/*
		for(j1 = 0;j1<201;j1++)mexPrintf("%f ",Y[j1]);
		mexPrintf("\n");
		for(j1 = 0;j1<200;j1++)mexPrintf("%f ",dt_NR[j1]);
		mexPrintf("\n");
		*/
		/*
		Cal_MCmean_cov_colwise(Epara,Nrec,Npara,IMHEmpara,IMHCovpara);
		band_choldc_c(IMHCovpara, IMHCCovpara, &Npara, &Npara);
		for(j1=0;j1<Npara;j1++){
			for(j2=0;j2<Npara;j2++){
				IMHCCovpara[j1+j2*Npara] /=imhfactor;
			}
		}
		printmatrix(IMHCCovpara,Npara,Npara);
		printmatrix(IMHEmpara,Npara,1);
		*/
		j1 = sprintf(buffer, "ACCP%d.txt", jnr);
		dat = fopen(buffer, "w");
		for (j2 = 0; j2 < Npara; j2++) {
			fprintf(dat, "%d ", ACCP[j2]);
		}
		fprintf(dat, "\n");
		fclose(dat);
		
		j1 = sprintf(buffer, "ACCy%d.txt", jnr);
		dat = fopen(buffer, "w");
		itmp = N1 * NObs * NLat;
		for (j2 = 0; j2 < itmp; j2++) {
			fprintf(dat, "%d ", ACCy[j2]);
			fprintf(dat, "\n");
		}
		fclose(dat);
		
		j1 = sprintf(buffer, "Epara%d.txt", jnr);
		dat = fopen(buffer, "w");
		k2 = 0;
		for (k1 = 0; k1 < Nrec; k1++) {
			for (j2 = 0; j2 < Npara; j2++) {
				fprintf(dat, "%8.5f ", Epara[k2]);
				k2++;
			}
			fprintf(dat, "\n");
		}
		fclose(dat);
		
		j1 = sprintf(buffer, "ACC_CR.txt");
		dat = fopen(buffer, "a");
		fprintf(dat, "NR=%d, ACC=%d", jnr, ACCy1);
		fprintf(dat, "\n");
		fclose(dat);
		
		j1 = sprintf(buffer, "ACC_bet_mh.txt");
		dat = fopen(buffer, "a");
		fprintf(dat, "NR=%d, ACC=%d, %d, %d, %d, %d, %d, %d\n", jnr, ACC_dyn_mh[0],ACC_dyn_mh[1],ACC_dyn_mh[2],ACC_dyn_mh[3],ACC_dyn_mh[4],ACC_dyn_mh[5],ACC_dyn_mh[6]);
		fclose(dat);
		
		j1 = sprintf(buffer, "ELamb%d.txt", jnr);
		dat = fopen(buffer, "w");
		k2 = 0;
		for (k1 = 0; k1 < Nrec; k1++) {
			for (j2 = 0; j2 < NLY; j2++) {
				fprintf(dat, "%8.3f ", ELY[k2]);
				k2++;
			}
			fprintf(dat, "\n");
		}
		fclose(dat);
		
		j1 = sprintf(buffer, "Emu%d.txt", jnr);
		dat = fopen(buffer, "w");
		k2 = 0;
		for (k1 = 0; k1 < Nrec; k1++) {
			for (j2 = 0; j2 < NZ; j2++) {
				fprintf(dat, "%8.3f ", EMU[k2]);
				k2++;
			}
			fprintf(dat, "\n");
		}
		fclose(dat);
		
		j1 = sprintf(buffer, "ESIG%d.txt", jnr);
		dat = fopen(buffer, "w");
		k2 = 0;
		for (k1 = 0; k1 < Nrec; k1++) {
			for (j2 = 0; j2 < NZ; j2++) {
				fprintf(dat, "%8.3f ", EPSI[k2]);
				k2++;
			}
			fprintf(dat, "\n");
		}
		fclose(dat);
		/*
		j1 = sprintf(buffer, "Yrec_%d.txt", jnr);
		dat = fopen(buffer, "w");
		for (k1 = 0; k1 < NObs; k1++) {
			for (k2 = 0; k2 < N1; k2++) {
				for(k3=0;k3<NLat;k3++){
					fprintf(dat, "%18.16f\n", Y[k1*N1*NLat+k2*NLat+k3]);
				}
			}			
		}
		fclose(dat);
		
		j1 = sprintf(buffer, "dtrec_%d.txt", jnr);
		dat = fopen(buffer, "w");
		for (k1 = 0; k1 < NObs; k1++) {
			for (k2 = 0; k2 < N1-1; k2++) {
				for(k3=0;k3<NLat;k3++){
					fprintf(dat, "%18.16f\n", dt_NR[k1*(N1-1)*NLat+k2*NLat+k3]);
				}
			}			
		}
		fclose(dat);
		*/
		
		
		
		
		
		if (jnr == 0) {
			/*mxFree(Y_mrp_new);
			mxFree(Y_mrp);
			
			mxFree(sdt_mrp);
			mxFree(dt_mrp);
			/*
			* free_dmatrix(EY0,0,Nrec-1,0,N10*NObs*NLat-1);
			*/
		} else {
			/*mxFree(Y_mrp_new);
			mxFree(Y_mrp);
			
			mxFree(sdt_mrp);
			mxFree(dt_mrp);
			/*
			* free_dmatrix(EY0,0,Nrec-1,0,N10*NObs*NLat-1);
			*/
		}
		
		mxFree(ACCP);
		mxFree(ACCy);
		mxFree(Y_new0);
		mxFree(Y_new);
		mxFree(Y2);
		mxFree(DX_new);
		
		mexPrintf("Resolution %d finished!!\n",jnr);
		
	}
	
	mxFree(ACCy_bs);
	
	mxFree(constr_mat1); 
	mxFree(constr_mat2);
	mxFree(constr_mat3);
	mxFree(constr_mat4);
	mxFree(constr_mat5);
	mxFree(ineq_flag1);
	mxFree(ineq_flag2);
	mxFree(ineq_flag3);
	mxFree(ineq_flag4);
	mxFree(ineq_flag5);
	mxFree(constr_a1);
	mxFree(constr_a2);
	mxFree(constr_a3);
	mxFree(constr_a4);
	mxFree(constr_a5);
	
	mxFree(constr_mat6);
	mxFree(ineq_flag6);
	mxFree(constr_a6);
	
	mxFree(constr_mat7);
	mxFree(ineq_flag7);
	mxFree(constr_a7);	
	
	mxFree(XV1);
	mxFree(Y1);
	
	mxFree(dt_NR);
	mxFree(sdt_NR);
	mxFree(dt_NR1);
	if (NNR == 1) {
		/*
		* free_dmatrix(EY,0,Nrec-1,0,N1*NObs*NLat-1);/*At last jnr, no EY is allcoated after EY is freed. Around line 450
		*/
	}
	
	mxFree(XV);
	mxFree(Y);
	mxFree(Epara);
	mxFree(Epara0);
	
	
	
	
	
	
	mxFree(vec_nobs);
	
	mxFree(IMHCCovpara);
	mxFree(IMHCovpara);
	mxFree(IMHEmpara);
	
	mxFree(IMHCCovpara0);
	mxFree(IMHCovpara0);
	mxFree(IMHEmpara0);
	
	
	
	mxFree(tuna);
	mxFree(EPSI0);
	mxFree(ELY0);
	mxFree(EMU0);
	
	mxFree(EPSI);
	mxFree(ELY);
	mxFree(EMU);
	
	
	
	free_imatrix(obsloc0,0,NObs-1,0,N0);
	free_imatrix(obsloc,0,NObs-1,0,N0);
	
	
	
	mxFree(mutmp);
	mxFree(Zvec);
	
	
	
	mxFree(SIG_new);
	mxFree(mu_new);
	mxFree(Lamb_new);
	
	mxFree(SIG);
	mxFree(mu);
	mxFree(Lamb);
	
	
	
	
	mxFree(Y0);
	mxFree(Z);
	
	
	mxFree(LFLamb);
	mxFree(NFLamb);
	mxFree(Zc);
	
	
	
	
	
	
	mxFree(yv_new);
	mxFree(numhyp);
	mxFree(para_new);
	mxFree(para);
	
	
	mxFree(PSLYdyn);
	mxFree(PLYdyn);
	mxFree(ROWdyn);
	mxFree(CLMdyn);
	
	mxFree(N01_ALL);
	mxFree(N0_ALL);
	
	

	
	mxFree(ymr_old);
	mxFree(ymr_new);
	
	mxFree(SIGMA0);
	mxFree(SIGMA);
	mxFree(L);
	mxFree(K);
	mxFree(P);
	mxFree(mu_lind);
	mxFree(b);
	mxFree(a);
	

	
	mxFree(X);
	
	mxFree(N1m1_ALL);
	
	gsl_rng_free (rgsl);

	
	/*
	free_dvector(NR_ALL,0,NNR-1);
	free_dvector(YM,0,NLat*NObs*((NR+1)*(N0)+1)-1);		
	free_dvector(para0,0,Npara-1);
	free_dvector(dt_NR0,0,NObs*((NR+1)*(N0))-1);
	free_dvector(yrange,0,NLat*(2)-1);
	free_dvector(pararange,0,Npara*2-1);
	free_dvector(tunaM,0,Npara-1);
	free_dvector(parahyp,0,Npara*3-1);
	free_dvector(numhyp0,0,Npara-1);
	free_dvector(Lamb0,0,NZ*NLat-1);
	free_dvector(ILamb,0,NZ*NLat-1);
	free_dvector(mu0,0,NZ);
	free_dvector(Imu,0,NZ);
	free_dvector(SIG0,0,NZ);
	free_dvector(SIGI,0,NZ);
	free_dvector(Z0,0,NZ*(N0+1)*NObs-1);
	free_dvector(Pmu,0,NZ*2);	
	free_dvector(PMLamb,0,NZ*NLat-1);
	free_dvector(PSLamb,0,NZ*NLat-1);
	free_dvector(PSIG,0,NZ*2);
	free_dvector(YM0,0,NLat*NObs*(N0+1)-1);	
	free_dvector(N0_ALL_M,0,NObs-1);
	free_dvector(Ytun,0,NLat-1);
	free_dvector(X0,0,NX*NObs-1);
	free_dvector(fobsloc,0,(N0+1)*NObs-1);
	*/
	
}
