#include "asa066.h"



/*Include any normalizing constant related to current state par*/
double para_prop_logden1(double par,double par_cur,double tun){
	return(-pow(par-par_cur,2)/(2*tun));
}

double para_prop_logden2(double par,double par_cur,double tun){
	return(-pow(log(par)-log(par_cur),2)/(2*tun)-log(par));
}


/*********************************************************************/

double para_prop_sampler1(double par_cur,double tun, long *idum){
	return(par_cur+gasdev(idum)*sqrt(tun));
}

double para_prop_sampler2(double par_cur,double tun, long *idum){
	return(exp(log(par_cur)+gasdev(idum)*sqrt(tun)));
}

/*********************************************************************/

double prior_logden1(double par, double *hyp){
	return(-0.5*pow(par-hyp[0],2)/(hyp[1]));
}

double prior_logden2(double par, double *hyp){
	return(-(hyp[0]+1)*log(par)-hyp[1]/par);
}

/*********************************************************************/
/*Include any normalizing constant related to current state Y*/

double Yobs_prop_logden1(double Y,double Y_cur,double tun){
	return(-pow(Y-Y_cur,2)/(2*tun));
}

double Yobs_prop_logden2(double Y,double Y_cur,double tun){
	return(-pow(log(Y)-log(Y_cur),2)/(2*tun)-log(Y));
}

/*********************************************************************/

double Yobs_prop_sampler1(double Y_cur,double tun, long *idum){
	return(Y_cur+gasdev(idum)*sqrt(tun));
}

double Yobs_prop_sampler2(double Y_cur,double tun, long *idum){
	return(exp(log(Y_cur)+gasdev(idum)*sqrt(tun)));
}

/*********************************************************************/

/*proposal density */



double yint_prop_logden(double y, double ymu, double yvar, double low1, double upp1, int i)
{
	double dtmp, dtmp1, dtmp2, dtmp3;
	if(i==0){
		dtmp=-pow(y-ymu, 2)/(2*yvar);
	}
	if(i==1){
		normp(low1,&dtmp1,&dtmp,&dtmp3);
		normp(upp1,&dtmp2,&dtmp,&dtmp3);
		dtmp=-0.5*log(yvar)-log(dtmp2-dtmp1)-pow(y-ymu, 2)/(2*yvar);						
	}
	return(dtmp);
}
